/*
Copyright (C) 2017 Hayakuchi

This file is part of HinesmPaint.

HinesmPaint is free software.
You can redistribute HinesmPaint and/or modify it under the GPL Licence version3 and LGPL Licence version 3.
(GPL text and LGPL text in http://www.gnu.org/licenses/)

このプログラムはフリーソフトです。
あなたはGPLライセンスversion3及びLGPLライセンスversion3の元でこのプログラムを改変、再配布することが可能です。
(GPLとLGPLの内容は http://www.gnu.org/licenses/)にあります)
*/

package hinesm.gazoushori;

import java.lang.Enum;
import java.lang.StringBuilder;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.FileNotFoundException;
import java.io.File;

public class ConfigFileRW
{
public static enum ConfigList
	{
OPEN_DIRECTORY(System.getProperty("user.home")),SUB_IMAGE(""),LAST_OPEN_IMAGE(""),LAYER_WIDTH("400"),LAYER_HEIGHT("400"),LINE_THICK("1");
private String valueContent;
private ConfigList()
		{
setValue("");
		}
private ConfigList(String s)
		{
setValue(s);
		}
public void setValue(String s)
		{
valueContent=s;
System.out.println(name()+"="+valueContent);
		}
@Override
public String toString()
		{
return valueContent;
		}
public static void setConfigValue(String name,String v)
		{
try
			{
ConfigList.valueOf(name).setValue(v);
			}
catch(Exception e)
			{
System.out.println("Can not set value("+name+"="+v+")\n"+e);
			}
		}
	};
/*設定読み込み高速化用*/

private static final String LINE_SEPARATOR=System.getProperty("line.separator");
private static final String FILE_SEPARATOR=System.getProperty("file.separator");
protected static final int READING_CONFIG_NAME=0;
protected static final int READING_CONFIG_VALUE=1;
/*デフォルト設定*/
public static String CONFIG_FILE=(System.getProperty("user.home"))+FILE_SEPARATOR+".hinesmpaintrc";

private ConfigFileRW()
	{;}
public static void readConfigFile()
	{
/*
	1.read config data.
*/
StringBuilder configString = new StringBuilder("");
try(BufferedReader br = new BufferedReader(new FileReader(CONFIG_FILE)))
		{
String str=br.readLine();
while(str!=null)
			{
configString.append(str);
configString.append(LINE_SEPARATOR);
str=br.readLine();
			}
		/*
			read and set value.
		*/
for(int i=0;i<configString.length();i++)
			{
if(configString.charAt(i)==' ' || configString.charAt(i)=='	')
				{
configString.deleteCharAt(i);
i--;
				}
			}
int state=0;
TemporaryConfig tmpConf= new TemporaryConfig(configString.toString());
for(int i=0;(i<configString.length());i++)
			{
char nowchar=configString.charAt(i);
boolean nowLine=LINE_SEPARATOR.equals(configString.substring(i,i+(LINE_SEPARATOR.length())));
switch(state)
				{
case READING_CONFIG_NAME://get value name
state=tmpConf.readConfigName(nowLine,nowchar);
break;
case READING_CONFIG_VALUE://get value content
state=tmpConf.readConfigValue(nowLine,nowchar);
break;
default:
break;
				}
if(nowLine)
				{
i=i+LINE_SEPARATOR.length()-1;
				}
if(nowchar=='#')
				{
i=configString.indexOf(LINE_SEPARATOR,i);
if(0<=i)
					{
i=i+LINE_SEPARATOR.length()-1;
					}
else
					{
i=configString.length();
					}
				}
			}
		}
catch(Exception e)
		{
if(e instanceof FileNotFoundException)
			{
System.out.println("make first setting");
			}
else
			{
e.printStackTrace();
			}
writeConfigFile();
		}
	}
public static void writeConfigFile()
	{
StringBuilder configString=new StringBuilder("");
for(ConfigList c: ConfigList.values())
		{
configString.append(c.name()+"="+c+LINE_SEPARATOR);
		}
System.out.println("configFile:"+CONFIG_FILE);
System.out.println(configString.toString());
try(BufferedWriter bw = new BufferedWriter(new FileWriter(new File(CONFIG_FILE))))
		{
bw.write(configString.toString());
		}
catch(Exception e)
		{
e.printStackTrace();
		}
	}
public static void setConfigValue(String name,String value)
	{
ConfigList.setConfigValue(name,value);	
	}
}
class TemporaryConfig
{
private String configString;
private StringBuilder configName=new StringBuilder("");
private StringBuilder configValue=new StringBuilder("");
private TemporaryConfig()
	{;}
TemporaryConfig(String str)
	{
configString=str;
	}
int readConfigName(boolean nowLine,char nowchar)
	{
if(!((nowLine) || (nowchar=='#')))
		{
if(nowchar=='=')
			{
return ConfigFileRW.READING_CONFIG_VALUE;
			}
else
			{
configName.append(nowchar);
			}
		}
else
		{
configName=new StringBuilder("");
configValue=new StringBuilder("");
		}
return ConfigFileRW.READING_CONFIG_NAME;
	}
int readConfigValue(boolean nowLine,char nowchar)
	{
if(nowLine || nowchar=='#')
		{
ConfigFileRW.setConfigValue(configName.toString(),configValue.toString());
configName=new StringBuilder("");
configValue=new StringBuilder("");
return ConfigFileRW.READING_CONFIG_NAME;
		}
else if((nowchar!='\"') && (nowchar!='\''))
		{
configValue.append(nowchar);
		}
return ConfigFileRW.READING_CONFIG_VALUE;
	}
}
