/*
Copyright (C) 2017 Hayakuchi

This file is part of HinesmPaint.

HinesmPaint is free software.
You can redistribute HinesmPaint and/or modify it under the GPL Licence version3 and LGPL Licence version 3.
(GPL text and LGPL text in http://www.gnu.org/licenses/)

このプログラムはフリーソフトです。
あなたはGPLライセンスversion3及びLGPLライセンスversion3の元でこのプログラムを改変、再配布することが可能です。
(GPLとLGPLの内容は http://www.gnu.org/licenses/)にあります)
*/

package hinesm.gazoushori;

import hinesm.util.gazobutton.*;
import hinesm.gazoushori.special.*;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.awt.Color;
import java.awt.Image;
import java.awt.image.BufferedImage;

public class GPanel extends BasePanel
{
public enum MessageSpicies
	{
DEFAULT("保存ボタンを押すと保存できます。"),PERFORMING("処理中です…"),SAVED("保存しました。"),ERROR("適切な画像を選ばない等予期せぬ動作、\nまたは未対応の不具合のようです。");
private String mes="";
private static MessageSpicies[] msar = MessageSpicies.values();
private MessageSpicies(String str)
		{
if(str!=null)
			{
mes=str;
			}
		}
public int getID()
		{
return ordinal()+1;
		}
public String getMessage()
		{
return mes;
		}
protected static String[] getMessages()
		{
String[] ret = new String[msar.length];
for(int i=0;i<msar.length;i++)
			{
ret[i]=msar[i].getMessage();
			}
return ret;
		}
	}
private static final long serialVersionUID = 1L;
public Color wmcol = new Color(0xff000000,true);
public static MessageWindow MW;
private static FOButton fob1;
private static FOButton fob2;
public static PButton pbot;
public static RadioButton rab;

private BufferedImage subimg;

private FOButton getMainImageOpenButton()
	{
return fob1;
	}
@Override
public void loopingPerform()
	{
makeButton();
	}
@Override
public void drawTopLayer(Graphics g)
	{
modePaint(g);
	}
@Override
public void drawBottomLayer(Graphics g)
	{
	}
public void makeButton()
	{
if(rab==null)
		{
rab = new RadioButton("処理を選んでください",this,((this.getWidth())/10),getHeight()/10,getWidth()*4/5,getHeight()*6/10,5,gazoushori.SHORI_MODE.線を引く.name(),gazoushori.SHORI_MODE.レイヤ関係.name(),gazoushori.SHORI_MODE.色置換.name(),gazoushori.SHORI_MODE.図形描画.name(),gazoushori.SHORI_MODE.塗りつぶし.name());
		}
if(fob1==null)
		{
int fob1width=getWidth()*7/20;
int fob1space=(getWidth()-(fob1width*2))/3;
int fob1height=getHeight()/20;
fob1=new FOButton("画像読み込み",this,fob1space,rab.getY()+rab.getHeight(),fob1width,fob1height);
		}
if(fob2==null && fob1!=null)
		{
fob2=new FOButton("補助画像読み込み",this,(fob1.getX()*2)+fob1.getWidth(),fob1.getY(),fob1.getWidth(),fob1.getHeight());
		}
if(pbot == null && fob1!=null)
		{
int pbotwidth=getWidth()/3;
int pbotspace= (getWidth()-pbotwidth)/2;
pbot = new PButton("この画像を保存",this,pbotspace,fob1.getY()+(fob1.getHeight()*2),pbotwidth,fob1.getHeight());
		}
if(MW==null && pbot!=null)
		{
MW=MessageWindow.createMessageWindow(this,getWidth()/10,pbot.getY()+(pbot.getHeight()*2),getWidth()*4/5,getHeight()/10,2,"画像と処理を選び、\n実行を押してください","処理中です...","保存しました。","適切な画像を選ばない等予期せぬ操作、\nまたは未対応の不具合のようです");
MW.setNowMessage(1);
System.out.println(MW.getNowMessage());
MW.setFrameFlg(false);
MW.setTitleColor(0xff000000,true);
		}
	}
public void readOpenFile(FOButton fob)
	{
if(fob==this.getMainImageOpenButton() && fob.getImage()!=null)
		{
if(fob.getLayersFlg())
			{
while(gazoushori.getImagePanel().getCanvasPanel().getLayerSize()>1)
				{
gazoushori.getImagePanel().getCanvasPanel().removeLayer(0);
				}
gazoushori.getImagePanel().getCanvasPanel().addLayer(fob.getImage(0));
for(int i=1;i<fob.length();i++)
				{
gazoushori.getImagePanel().getCanvasPanel().addLayer(fob.getImage(i));
				}
gazoushori.getSubPanel().reloadImageSize();
			}
else
			{
gazoushori.getImagePanel().setNewImage(fob.getImage());
			}
		}
else
		{
subimg=fob.getImage(0);
gazoushori.getSubPanel().spimg.setSubImage(subimg);
if(subimg!=null)
			{
ConfigFileRW.ConfigList.setConfigValue("SUB_IMAGE",ConfigFileRW.ConfigList.LAST_OPEN_IMAGE.toString());
			}
		}
	}
private BufferedImage getSubImage()
	{
return subimg;
	}
public void modePaint(Graphics g)
	{
if(rab!=null)
		{
switch(rab.getSelection())
			{
case 0:
break;
case 1:
break;
case 2:
break;
default:
break;
			}
		}
	}
public void setNowMessage(MessageSpicies ms)
	{
if(MW!=null)
		{
MW.setNowMessage(ms.getID());
		}
	}
@Override
public void mousePressed(MouseEvent e)
	{
if(pbot!=null && this!=null && MW!=null && gazoushori.getImagePanel()!=null)
			{
pbot.setInstansPerformButton(gazoushori.getImagePanel().getCanvasPanel().getPileImage());
			}
super.mousePressed(e);
	}
}
