/*
Copyright (C) 2017 Hayakuchi

This file is part of HinesmPaint.

HinesmPaint is free software.
You can redistribute HinesmPaint and/or modify it under the GPL Licence version3 and LGPL Licence version 3.
(GPL text and LGPL text in http://www.gnu.org/licenses/)

このプログラムはフリーソフトです。
あなたはGPLライセンスversion3及びLGPLライセンスversion3の元でこのプログラムを改変、再配布することが可能です。
(GPLとLGPLの内容は http://www.gnu.org/licenses/)にあります)
*/

package hinesm.gazoushori;

import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.awt.Color;
import java.awt.event.MouseEvent;
import hinesm.util.gazobutton.*;
import hinesm.gazoushori.special.*;

public class NIPanel extends BasePanel
{
	
private static final long serialVersionUID=1L;
CanvasPanel cp;

UndoButton ub;
RedoButton rb;

int rectangleWidth;
int rectangleHeight;

int draggingX=0;
int draggingY=0;

int pressedX=0;
int pressedY=0;

ScrollBar scrollX;
ScrollBar scrollY;

@Override
public void drawBottomLayer(Graphics g)
	{;}
@Override
public void drawTopLayer(Graphics g)
	{
g.setColor(Color.DARK_GRAY);
switch(gazoushori.getNowShoriMode())
		{
case 線を引く:
try
			{
if((!(gazoushori.getSubPanel().getFreeLine()))&&(cp.getMouseDraggingFlg()))
				{
g.drawLine(pressedX,pressedY,draggingX,draggingY);
				}
			}
catch(NullPointerException e)
			{;}
break;
case 図形描画:
if(cp.getMouseDraggingFlg())
			{
g.drawRect(pressedX-rectangleWidth,pressedY-rectangleHeight,rectangleWidth*2,rectangleHeight*2);
g.setColor(Color.black);
g.drawOval(pressedX-rectangleWidth,pressedY-rectangleHeight,rectangleWidth*2,rectangleHeight*2);
			}
break;
default:
break;
		}
	}
@Override
public void loopingPerform()
	{
makeButton();
if(scrollX!=null && scrollY!=null && cp!=null)
		{
cp.setImageLocation(scrollX.getLocate(),scrollY.getLocate());
		}
switch(gazoushori.getNowShoriMode())
		{
case 線を引く:
try
			{
if((!gazoushori.getSubPanel().getFreeLine())&&cp.getMouseDraggingFlg())
				{
gazoushori.getSubPanel().setSubX(cp.getDraggedX());
gazoushori.getSubPanel().setSubY(cp.getDraggedY());
				}
			}
catch(NullPointerException e)
			{;}
break;
case 図形描画:
if(cp.getMouseDraggingFlg())
			{
rectangleWidth=Math.abs(cp.getPressedX()-cp.getDraggedX());
rectangleHeight=Math.abs(cp.getPressedY()-cp.getDraggedY());
if(gazoushori.getSubPanel()!=null)
				{
 if((gazoushori.getSubPanel().circlerb!=null) && ((gazoushori.getSubPanel().circlerb.getSelection()!=1) && (gazoushori.getSubPanel().circlerb.getSelection()!=3)))
					{
rectangleHeight=rectangleWidth;
					}
gazoushori.getSubPanel().setHalfWidth(rectangleWidth);
gazoushori.getSubPanel().setHalfHeight(rectangleHeight);
				}
			}
break;
default:
break;
		}
	}
private void makeButton()
	{
if(scrollX==null)
		{
scrollX= new ScrollBar(0,getHeight()*9/10,getHeight()/20,getWidth()*9/10,ScrollBar.MODE_HORIZONTAL,0,this);
		}
if(scrollY==null)
		{
scrollY = new ScrollBar(getWidth()*9/10,0,getWidth()/20,getHeight()*9/10,ScrollBar.MODE_VERTICAL,0,this);
		}
if((cp==null) && (scrollX!=null) && (scrollY!=null))
		{
cp= new CanvasPanel(this,scrollX,scrollY,0,0,getWidth()*9/10,getHeight()*9/10);
		}
if(ub==null && cp!=null)
		{
ub= new UndoButton(cp,0,getHeight()*19/20,getWidth()/10,getHeight()/20);
		}
if(rb==null && ub!=null)
		{
rb= new RedoButton(cp,ub.getWidth(),getHeight()*19/20,getWidth()/10,getHeight()/20);
		}
	}

public void setImage(BufferedImage bi)
	{
cp.setImage(bi);
	}
public void setNewImage(BufferedImage bi)
	{
cp.setNewImage(bi);
	}
public void setImage(BufferedImage bi,int layernum)
	{
cp.setImage(bi,layernum);
	}
public void setNewImage(BufferedImage bi,int layernum)
	{
cp.setNewImage(bi,layernum);
	}
public BufferedImage getNowImage()
	{
return cp.getNowImage();
	}
public BufferedImage getImage(int layernum)
	{
return cp.getImage(layernum);
	}
public BufferedImage getDrawingImage()
	{
return cp.getDrawingImage();
	}
public CanvasPanel getCanvasPanel()
	{
return cp;
	}
@Override
public void mouseReleased(MouseEvent e)
	{
super.mouseReleased(e);
if(cp.containCheck(e.getX(),e.getY()))
		{
switch(gazoushori.getNowShoriMode())
			{
case 線を引く:
if(!gazoushori.getSubPanel().getFreeLine())
				{
gazoushori.shori();
				}
break;
case 図形描画:
case 塗りつぶし:
gazoushori.shori(gazoushori.getNowShoriMode());
break;
default:
break;
			}
		}
	}
@Override
public void mousePressed(MouseEvent e)
	{
super.mousePressed(e);
pressedX=e.getX();
pressedY=e.getY();
if(cp.containCheck(e.getX(),e.getY()))
		{
switch(gazoushori.getNowShoriMode())
			{
case 線を引く:
case 図形描画:
case 塗りつぶし:
gazoushori.getSubPanel().setCenterX(cp.getPressedX());
gazoushori.getSubPanel().setCenterY(cp.getPressedY());
break;
default:
break;
			}
		}
	}
@Override
public void mouseDragged(MouseEvent e)
	{
super.mouseDragged(e);
draggingX=e.getX();
draggingY=e.getY();
	}
public void setNowLayer(int n)
	{
cp.setNowLayer(n);
	}
public void undo()
	{
cp.undo();
	}
public void redo()
	{
cp.redo();
	}
}
