/*
Copyright (C) 2017 Hayakuchi

This file is part of HinesmPaint.

HinesmPaint is free software.
You can redistribute HinesmPaint and/or modify it under the GPL Licence version3 and LGPL Licence version 3.
(GPL text and LGPL text in http://www.gnu.org/licenses/)

このプログラムはフリーソフトです。
あなたはGPLライセンスversion3及びLGPLライセンスversion3の元でこのプログラムを改変、再配布することが可能です。
(GPLとLGPLの内容は http://www.gnu.org/licenses/)にあります)
*/


package hinesm.gazoushori;

import java.awt.image.BufferedImage;
import java.io.File;
import java.io.BufferedReader;
import java.io.FileReader;
import javax.swing.JFileChooser;
import javax.imageio.ImageIO;

public class ReadImage
{
private ReadImage()
	{
	}

public static BufferedImage[] openReadDialog()
	{
BufferedImage[] ret = new BufferedImage[0];
JFileChooser jfc = new JFileChooser();
try
		{
jfc.setCurrentDirectory(new File(ConfigFileRW.ConfigList.OPEN_DIRECTORY.toString()));
		}
catch(Exception e)
		{
jfc.setCurrentDirectory(new File(System.getProperty("user.home")));
		}
if(jfc.showDialog(null,"開く")==JFileChooser.APPROVE_OPTION)
		{
ret=read(jfc.getSelectedFile());
ConfigFileRW.setConfigValue("LAST_OPEN_IMAGE",jfc.getSelectedFile().toString());
ConfigFileRW.setConfigValue("OPEN_DIRECTORY",jfc.getSelectedFile().getParent());
		}
return ret;
	}
public static BufferedImage[] read(File file)
	{
boolean ifTxt = (0<=(file.getName().indexOf(".txt")));
BufferedImage[] ret = new BufferedImage[0];
try
		{
if(ifTxt)
			{
ret=readLayersText(file);
			}
else
			{
ret=new BufferedImage[1];
ret[0]=ImageIO.read(file);
			}
		}
catch(Exception e)
		{
e.printStackTrace();
		}
return ret;
	}
private static BufferedImage[] readLayersText(File file)
	{
String openDirectory=file.getAbsolutePath().substring(0,(file.getAbsolutePath().length()-4));
StringBuilder inFileString=new StringBuilder();
BufferedImage[] ret=new BufferedImage[0];
System.out.println(openDirectory);
//テキスト読み込み
try(BufferedReader br = new BufferedReader(new FileReader(file)))
		{
String str=br.readLine();
while(str!=null)
			{
inFileString.append(str);
str=br.readLine();
			}
		}
catch(Exception e)
		{
e.printStackTrace();
		}
//レイヤ数を数える
int semNum=0;
int searchNum=inFileString.indexOf(";",0);
while(searchNum>=0)
		{
semNum++;
searchNum=inFileString.indexOf(";",searchNum+1);
		}
ret= new BufferedImage[semNum];
//レイヤを読み込む
int endNum=-1;
for(int i=0;i<semNum;i++)
		{
StringBuilder name= new StringBuilder("");
searchNum=endNum+1;
endNum=inFileString.indexOf(";",endNum+1);
while(searchNum<endNum)
			{
char appendc = inFileString.charAt(searchNum);
if((appendc!='\n') && (appendc!='\r'))
				{
name.append(appendc);
				}
searchNum++;
			}
try
			{
ret[i]=ImageIO.read(new File(openDirectory+File.separator+name.toString()));
			}
catch(Exception e)
			{
ret[i]=null;
e.printStackTrace();
			}
		}
return ret;
	}
}
