/*
Copyright (C) 2017 Hayakuchi

This file is part of HinesmPaint.

HinesmPaint is free software.
You can redistribute HinesmPaint and/or modify it under the GPL Licence version3 and LGPL Licence version 3.
(GPL text and LGPL text in http://www.gnu.org/licenses/)

このプログラムはフリーソフトです。
あなたはGPLライセンスversion3及びLGPLライセンスversion3の元でこのプログラムを改変、再配布することが可能です。
(GPLとLGPLの内容は http://www.gnu.org/licenses/)にあります)
*/
package hinesm.gazoushori;

import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.Image;
import java.awt.image.BufferedImage;
import hinesm.util.gazobutton.*;
import hinesm.gazoushori.special.SaveLayerInfoButton;
import hinesm.gazoushori.special.PButton;
import hinesm.gazoushori.special.CanvasPanel;
import hinesm.gazoushori.special.SPSubImage;
import hinesm.gazoushori.special.ManageLayerPanel;
import hinesm.gazoushori.special.NuriControlPanel;

public class SPanel extends BasePanel
{
enum LINETYPE{自由,直線;};
enum LINETHICK{固定,可変,筆圧検知;};
enum LINEANTI{有効,無効;};

private static final long serialVersionUID = 1L;
Graphics maing;
Graphics subg;
Image bfimg;

RadioButton filterradio;
PButton olpb;
SaveLayerInfoButton slib;
ManageLayerPanel mlp;

private GazoText circlet1;//x位置
private GazoText circlet2;//y位置
private GazoText circlet3;//幅の半分
private GazoText circlet4;//高さの半分
private GazoText circlet5;//同心楕円を描く回数
private GazoText circlet6;//同心楕円の高さ間隔
private GazoText circlet7;//同心楕円の幅間隔
RadioButton circlerb;//円の種類を選べる

private GazoText subX;//補助X位置
private GazoText subY;//補助Y位置

private GazoText color1;//色全般これに依存
private GazoText color2;//色指定の補助

private RadioButton linetype;//線の種類
private GazoText lineThick;//線の太さ
private RadioButton linerb;//線の種類を選べる
private RadioButton mvthick;//線の太さが可変かどうか調べる

RadioButton nuriradio;//塗りのタイプを選ぶ
private NuriControlPanel nuriP;
MessageWindow MW;

SPSubImage spimg;

private int messageWindowWidth;
private int messageWindowHeight;

private int activeSpaceX;
private int activeSpaceY;
private int activeSpaceWidth;
private int activeSpaceHeight;

public void setActiveSpace(int x,int y,int width,int height)
	{
activeSpaceX=x;
activeSpaceY=y;
activeSpaceWidth=width;
activeSpaceHeight=height;
	}
public int getActiveSpaceX()
	{return activeSpaceX;}
public int getActiveSpaceY()
	{return activeSpaceY;}
public int getActiveSpaceWidth()
	{return activeSpaceWidth;}
public int getActiveSpaceHeight()
	{return activeSpaceHeight;}
public void setMessageWindowSize(int width,int height)
	{messageWindowWidth=width;
	messageWindowHeight=height;}
public int getSubImagePanelWidth()
	{return messageWindowWidth;}
public int getSubImagePanelHeight()
	{return messageWindowHeight;}
public String getSelectionString()
	{
return filterradio.getRBTitle(filterradio.getSelection());
	}
private void makeButton()
	{
if(MW==null)
		{
int MW_X=0;
int MW_WIDTH=messageWindowWidth;
int MW_HEIGHT=messageWindowHeight;
int MW_Y=(getHeight()-1)-MW_HEIGHT;
MW=MessageWindow.createMessageWindow(this,MW_X,MW_Y,MW_WIDTH,MW_HEIGHT,4);
		}
if(MW!=null)
		{
if(MW.getTheNumberOfMessage()==0)
			{
MW.setMessage("指定した太さの\n線や直線を引きます。\nアンチエイリアスとは\n線をぼかす処理です。",true,-1);
MW.setMessage("重ね合わせの設定など、\nレイヤに関する機能を使用します。\n重ねあわせの種類を\n選んだりできます。",true,-1);
MW.setMessage("画像1の色の置換を行います。\n上の入力欄に入れた色を、\n下の入力欄の色に変換します。\n(色はRGB値またはARGB値です)",true,-1);

MW.setMessage("画像1に円系の図形を描きます。\n描きたい図形を選び、\n必要事項を入力するか、\n右画面を操作して下さい",true,-1);
MW.setMessage("画像1に塗りつぶし処理を行います。\nクリックした位置から、\n塗りつぶし処理を行います",true,-1);
MW.setMessage("左上で処理を選んで下さい。",true,-1);
			}
		}
if(mlp==null && MW != null && gazoushori.getImagePanel()!=null && gazoushori.getImagePanel().getCanvasPanel()!=null)
		{
int mlpHeight=getHeight()-(getActiveSpaceHeight()+MW.getHeight());
mlp=new ManageLayerPanel(this,gazoushori.getImagePanel().getCanvasPanel(),MW.getX(),MW.getY()-mlpHeight,getWidth()/2,mlpHeight);
		}
if(spimg==null && mlp!=null)
			{
spimg=new SPSubImage(this,mlp.getX()+mlp.getWidth()+1,mlp.getY(),getWidth()-mlp.getWidth()-2,mlp.getHeight());
			}
//のこり40%
if(circlet1 ==null && MW !=null && spimg !=null)
		{
//x
int chx=activeSpaceX+getWidth()/20;
int textSpaceRank=7;
circlet1= new GazoText("X位置",this,chx,activeSpaceY,((activeSpaceWidth-(chx*2))/2),activeSpaceHeight/textSpaceRank,5);
		}
if(circlet2 == null && circlet1 != null)
		{
//y
circlet2= new GazoText("Y位置",this,circlet1.getX()+circlet1.getWidth(),circlet1.getY(),circlet1.getWidth(),circlet1.getHeight(),5);
		}
if(subX==null && circlet2!=null)
		{
subX= new GazoText("補助X位置",this,circlet1.getX(),circlet1.getHeight()+circlet1.getY(),circlet1.getWidth(),circlet1.getHeight(),5);
		}
if(circlet3 == null && circlet1 != null)
		{
//height
circlet3= new GazoText("幅の半分",this,circlet1.getX(),circlet1.getHeight()+circlet1.getY(),circlet1.getWidth(),circlet1.getHeight(),5);
		}
if(subY == null && circlet3 !=null)
		{
subY= new GazoText("補助Y位置",this,circlet3.getX()+circlet3.getWidth(),circlet3.getY(),circlet3.getWidth(),circlet3.getHeight(),5);
		}
if(circlet4 == null && circlet3 !=null)
		{
//width
circlet4= new GazoText("高さの半分",this,circlet3.getX()+circlet3.getWidth(),circlet3.getY(),circlet3.getWidth(),circlet3.getHeight(),5);
		}
if(circlet5 == null && circlet1 != null)
		{
//kaisuu
circlet5= new GazoText("回数",this,circlet1.getX(),circlet1.getY()+(circlet1.getHeight()*2),(activeSpaceWidth-(circlet1.getX()*2))/5,circlet1.getHeight(),3);
		}
if(circlet6 == null && circlet5 != null)
		{
circlet6= new GazoText("図形の幅",this,circlet5.getX()+circlet5.getWidth(),circlet5.getY(),(circlet5.getWidth()*2),circlet5.getHeight(),5);
		}
if(circlet7 == null && circlet6!=null)
		{
circlet7= new GazoText("図形の高さ",this,circlet6.getX()+circlet6.getWidth(),circlet6.getY(),circlet6.getWidth(),circlet6.getHeight(),5);
		}
if(color1 == null && circlet1!= null)
		{
color1=new GazoText("色(RGBかARGB)",this,circlet1.getX(),circlet1.getY()+(circlet1.getHeight()*3),(activeSpaceWidth-(circlet1.getX()*2)),circlet1.getHeight(),12);
color1.setTitle("#ff000000");
		}
if(color2 ==null && color1!=null)
		{
color2 = new GazoText("色(RGBかARGB)",this,color1.getX(),color1.getY()+color1.getHeight(),color1.getWidth(),color1.getHeight(),12);
color2.setTitle("#ff000000");
		}
if((circlerb==null) && (color1!=null))
		{
circlerb = new RadioButton("描く図形の種類",this,color1.getX(),color1.getY()+color1.getHeight(),color1.getWidth()*2/3,(color1.getHeight()*2),2,"円","楕円","同心円","同心楕円");
		}
if((nuriP==null) && (color1!=null))
		{
nuriP= new NuriControlPanel(this,color1.getX(),color1.getY()-(color1.getHeight()*2),color1.getWidth(),color1.getHeight()*2);
		}
if(nuriradio == null && color1!=null)
		{
nuriradio= new RadioButton("塗り潰しの種類",this,color1.getX(),color1.getY()+color1.getHeight(),color1.getWidth(),color1.getHeight()+color1.getHeight(),"色塗り潰し","テクスチャ","貼り付け");
		}
if(filterradio ==null && nuriradio!=null)
		{
filterradio=new RadioButton("重ね合わせの種類",this,nuriradio.getX(),nuriradio.getY(),nuriradio.getWidth(),nuriradio.getHeight(),CanvasPanel.FILTER_NUMBER.values());
		}
if(olpb==null && (color2!=null) && (filterradio!=null))
		{
olpb= new PButton("現在のレイヤを保存",this,filterradio.getX(),filterradio.getY()-color2.getHeight(),color2.getWidth()/2,color2.getHeight());
		}
if((slib==null)&&(olpb!=null))
		{
slib= new SaveLayerInfoButton(gazoushori.getImagePanel().getCanvasPanel(),"レイヤ情報を保存",this,olpb.getX()+olpb.getWidth(),olpb.getY(),olpb.getWidth(),olpb.getHeight());
		}
if((linetype==null)&&(circlerb!=null)&&(color1!=null))
		{
linetype=new RadioButton("線の種類",this,color1.getX(),circlerb.getY(),color1.getWidth()/4,circlerb.getHeight(),SPanel.LINETYPE.values());
		}
if((mvthick==null)&&(linetype!=null)&&(color1!=null))
		{
mvthick=new RadioButton("線の太さ",this,linetype.getX()+linetype.getWidth(),linetype.getY(),color1.getWidth()/2,linetype.getHeight(),SPanel.LINETHICK.values());
		}
if((linerb==null)&&(mvthick!=null))
		{
linerb= new RadioButton("アンチエイリアス",this,mvthick.getX()+mvthick.getWidth(),mvthick.getY(),color1.getWidth()/4,color1.getHeight()*2,2,SPanel.LINEANTI.values());
		}
if((lineThick==null)&&(linerb!=null))
		{
lineThick= new GazoText("線の太さ",this,color1.getX(),linerb.getY()+(linerb.getHeight()),color1.getWidth(),linerb.getHeight()/2){
@Override
public void keyTypedPerform(KeyEvent e)
	{
super.keyTypedPerform(e);
if(this.thisTabNow())
		{
ConfigFileRW.ConfigList.LINE_THICK.setValue(this.getTitle());
		}
	}
};
lineThick.setTitle(ConfigFileRW.ConfigList.LINE_THICK.toString());
		}
	}
public void loopingPerform()
	{
makeButton();
switch(gazoushori.getNowShoriMode())
		{
case 線を引く:
GazoButton.setActiveAll(this,MW,spimg,mlp,color1,lineThick,linerb,linetype,mvthick);
if(linetype!=null)
			{
if(circlet1!=null)
				{
circlet1.setActiveFlg(!getFreeLine());
				}
if(subX!=null)
				{
subX.setActiveFlg(!getFreeLine());
				}
if(circlet2!=null)
				{
circlet2.setActiveFlg(!getFreeLine());
				}
if(subY!=null)
				{
subY.setActiveFlg(!getFreeLine());
				}
			}
break;
case レイヤ関係:
GazoButton.setActiveAll(this,MW,filterradio,spimg,mlp,olpb,slib);
break;
case 色置換:
GazoButton.setActiveAll(this,color2,color1,MW,spimg,mlp);
break;
case 図形描画:
GazoButton.setActiveAll(this,circlet1,circlet2,circlet3,color1,circlerb,MW,spimg,mlp);
if(circlerb!=null)
			{
if((circlerb.getSelection()==1 || circlerb.getSelection()==3) && circlet4!=null)
				{
circlet4.setActiveFlg(true);
				}
if((circlerb.getSelection()==2 || circlerb.getSelection()==3) && circlet5!=null && circlet6!=null)
				{
circlet5.setActiveFlg(true);
circlet6.setActiveFlg(true);
if(circlerb.getSelection()==3 && circlet7!=null)
					{
circlet7.setActiveFlg(true);
					}
				}
			}
break;
case 塗りつぶし:
GazoButton.setActiveAll(this,circlet1,circlet2,color1,nuriradio,MW,spimg,mlp,nuriP);
break;
default:
GazoButton.setActiveAll(this,MW,spimg,mlp);
break;
		}
MW.setNowMessage(gazoushori.getNowShoriMode().ordinal()+1);
	}
public BufferedImage getSubImage()
	{
return spimg.getSubImage();
	}
public void drawTopLayer(Graphics g)
	{;}
public void drawBottomLayer(Graphics g)
	{;}
@Override
public void mousePressed(MouseEvent e)
	{
if(olpb!=null && olpb.containCheck(e.getX(),e.getY()))
		{
olpb.setInstansPerformButton(gazoushori.getImagePanel().getNowImage());
		}
super.mousePressed(e);
if(gazoushori.getNowShoriMode()==gazoushori.SHORI_MODE.レイヤ関係 && filterradio.containCheck(e.getX(),e.getY()));
		{
gazoushori.shori(gazoushori.SHORI_MODE.レイヤ関係);
		}
	}
//数値
public String getCenterX()
	{
return circlet1.getTitle();
	}
public String getCenterY()
	{
return circlet2.getTitle();
	}
public String getSubY()
	{
return subY.getTitle();
	}
public String getSubX()
	{
return subX.getTitle();
	}
public String getHalfWidth()
	{
return circlet3.getTitle();
	}
public String getHalfHeight()
	{
return circlet4.getTitle();
	}
public String getCircleNum()
	{
return circlet5.getTitle();
	}
public String getDiaglamSpaceHeight()
	{
return circlet7.getTitle();
	}
public String getDiaglamSpaceWidth()
	{
return circlet6.getTitle();
	}
public String getColor1()
	{
return color1.getTitle();
	}
public String getColor2()
	{
return color2.getTitle();
	}
public String getThick()
	{
return lineThick.getTitle();
	}
public boolean getAntiAliasMode()
	{
return linerb.getSelection()==SPanel.LINEANTI.有効.ordinal();
	}
public boolean getMoveThick()
	{
return mvthick.getSelection()==SPanel.LINETHICK.可変.ordinal();
	}
public boolean getUsePentab()
	{
return mvthick.getSelection()==SPanel.LINETHICK.筆圧検知.ordinal();
	}
public boolean getFreeLine()
	{
return linetype.getSelection()==SPanel.LINETYPE.自由.ordinal();
	}
public int nuriBorder()
	{
return nuriP.nuriAllowNum();
	}
public void setCenterX(int x)
	{
circlet1.setTitle(Integer.toString(x));
	}
public void setCenterY(int y)
	{
circlet2.setTitle(Integer.toString(y));
	}
public void setSubX(int x)
	{
subX.setTitle(Integer.toString(x));
	}
public void setSubY(int y)
	{
subY.setTitle(Integer.toString(y));
	}
public void setHalfWidth(int width)
	{
circlet3.setTitle(Integer.toString(width));
	}
public void setHalfHeight(int height)
	{
circlet4.setTitle(Integer.toString(height));
	}
public void reloadImageSize()
	{
mlp.reloadImageSize();
	}
}
