/*
Copyright (C) 2017 Hayakuchi

This file is part of HinesmPaint.

HinesmPaint is free software.
You can redistribute HinesmPaint and/or modify it under the GPL Licence version3 and LGPL Licence version 3.
(GPL text and LGPL text in http://www.gnu.org/licenses/)

このプログラムはフリーソフトです。
あなたはGPLライセンスversion3及びLGPLライセンスversion3の元でこのプログラムを改変、再配布することが可能です。
(GPLとLGPLの内容は http://www.gnu.org/licenses/)にあります)
*/

package hinesm.gazoushori;

import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileWriter;
import java.io.BufferedWriter;
import javax.imageio.ImageIO;
import javax.swing.JFileChooser;
import hinesm.util.gazobutton.MessageWindow;
import hinesm.gazoushori.special.CanvasPanel;

public class WriteImage
{
private WriteImage()
	{;}
public static void write(BufferedImage image,File file)
	{
write(image,gazoushori.getNowImageType(),file);
	}
public static void write(BufferedImage image,String fileName)
	{
write(image,gazoushori.getNowImageType(),fileName);
	}
public static void write(BufferedImage image,String imageType,String fileName)
	{
write(image,imageType,new File(fileName));
	}
public static void write(BufferedImage image,String imageType,File file)
	{
try
		{
if(gazoushori.getGeneralPanel()!=null)
			{
gazoushori.getGeneralPanel().setNowMessage(GPanel.MessageSpicies.PERFORMING);
			}
String fileType=file.getName().substring(file.getName().lastIndexOf(".")+1,file.getName().length());
if(ImageIO.write(image,fileType,file) || ImageIO.write(image,imageType,file) || ImageIO.write(image,"png",file))
			{
successWrite(file);
			}
else
			{
failedWrite(file);
			}
		}
catch(Exception e)
		{
e.printStackTrace();
failedWrite(file);
		}
try
		{
ConfigFileRW.setConfigValue("OPEN_DIRECTORY",file.getParentFile().getAbsolutePath());
		}
catch(Exception e)
		{
e.printStackTrace();
		}
	}
private static void failedWrite(File file)
	{
if(file!=null)
		{
if(gazoushori.getGeneralPanel()!=null)
			{
gazoushori.getGeneralPanel().setNowMessage(GPanel.MessageSpicies.ERROR);
			}
System.out.println("failed save "+file.getName()+"("+file.getAbsolutePath()+")");
		}
else
		{
System.out.println("selected file is null");
		}
	}
private static void successWrite(File file)
	{
if(gazoushori.getGeneralPanel()!=null)
		{
gazoushori.getGeneralPanel().setNowMessage(GPanel.MessageSpicies.SAVED);
		}
System.out.println("success save "+file.getName());
	}
public static File openSaveDialog()
	{
return openSaveDialog("保存する");
	}
public static File openSaveDialog(String mes)
	{
return openSaveDialog("png",mes);
	}
public static File openSaveDialog(String defaultType,String mes)
	{
JFileChooser jfc = new JFileChooser();
try
		{
jfc.setCurrentDirectory(new File(ConfigFileRW.ConfigList.OPEN_DIRECTORY.toString()));
		}
catch(Exception e)
		{
jfc.setCurrentDirectory(new File(System.getProperty("user.home")));
		}
jfc.setSelectedFile(new File(jfc.getCurrentDirectory().getAbsolutePath()+File.separator+"newFile."+defaultType));

if(jfc.showDialog(null,mes) == JFileChooser.APPROVE_OPTION)
		{
return jfc.getSelectedFile();
		}
return null;
	}
public static void openSaveDialog(BufferedImage image)
	{
write(image,openSaveDialog());
	}
public static void openSaveDialog(BufferedImage image,String mes)
	{
write(image,openSaveDialog(mes));
	}
public static void openSaveDialog(CanvasPanel useCanvasPanel)
	{
if(useCanvasPanel!=null)
		{
File layertxt = WriteImage.openSaveDialog(".txt","レイヤ情報保存");
if(layertxt!=null)
			{
String layerDirectory=layertxt.getName();
if("txt".equals(layerDirectory.substring(layerDirectory.lastIndexOf(".")+1,layerDirectory.length())))
				{
layerDirectory=layertxt.getAbsolutePath().substring(0,layertxt.getAbsolutePath().indexOf("."));
				}
else
				{
layerDirectory=layertxt.getAbsolutePath();
layertxt=new File(layertxt+".txt");
				}

File ldfile = new File(layerDirectory);
if(!(ldfile.exists()))
				{
ldfile.mkdir();
				}

try(BufferedWriter bw = new BufferedWriter(new FileWriter(layertxt)))
				{
for(int i=0;i<useCanvasPanel.getLayerSize();i++)
					{
bw.write("image"+String.valueOf(i)+"."+gazoushori.getNowImageType()+";\n");
					}
bw.flush();
				}
catch(Exception e)
				{
e.printStackTrace();
System.out.println("failed save "+layertxt.getName()+"("+layertxt.getAbsolutePath()+")");
return;
				}
for(int i=0;i<useCanvasPanel.getLayerSize();i++)
				{
WriteImage.write(useCanvasPanel.getImage(i),new File(layerDirectory+File.separator+"image"+String.valueOf(i)+"."+gazoushori.getNowImageType()));
				}
ConfigFileRW.setConfigValue("OPEN_DIRECTORY",layertxt.getParentFile().getAbsolutePath());
			}
		}
	}
}
