/*
Copyright (C) 2017 Hayakuchi

This file is part of HinesmPaint.

HinesmPaint is free software.
You can redistribute HinesmPaint and/or modify it under the GPL Licence version3 and LGPL Licence version 3.
(GPL text and LGPL text in http://www.gnu.org/licenses/)

このプログラムはフリーソフトです。
あなたはGPLライセンスversion3及びLGPLライセンスversion3の元でこのプログラムを改変、再配布することが可能です。
(GPLとLGPLの内容は http://www.gnu.org/licenses/)にあります)
*/

package hinesm.gazoushori;

import java.awt.Insets;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.ComponentEvent;
import java.awt.event.WindowEvent;
import java.awt.event.WindowAdapter;
import hinesm.gazoushori.special.ImageCanvas;
import hinesm.gazoushori.special.CanvasPanel;
import hinesm.util.gazobutton.GazoButton;
import hinesm.util.gazobutton.GazoFrame;

public class gazoushori extends GazoFrame
{

public enum SHORI_MODE{線を引く,レイヤ関係,色置換,図形描画,塗りつぶし;};
private static final long serialVersionUID = 1L;
private static String saveType="png";

private static SHORI_MODE mode = SHORI_MODE.線を引く;

public static gazoushori g;
public static boolean redflg = false;

public static final int LEFT_PANEL_WIDTH=350;
public static final int ABOVE_PANEL_HEIGHT=450;

public static final int DEFAULT_JF_X=0;
public static final int DEFAULT_JF_Y=0;
public static int DEFAULT_JF_WIDTH=LEFT_PANEL_WIDTH;
public static int DEFAULT_JF_HEIGHT=ABOVE_PANEL_HEIGHT;

private static NIPanel ip;
private static GPanel gp;
private static SPanel sp;

public static void createGeneralPanel()
	{
gp=new GPanel();
	}
public static void createSubPanel()
	{
sp=new SPanel();
	}
public static void createImagePanel()
	{
ip=new NIPanel();
	}
public static NIPanel getImagePanel()
	{
return ip;
	}
public static GPanel getGeneralPanel()
	{
return gp;
	}
public static SPanel getSubPanel()
	{
return sp;
	}
public void loopingPerform()
	{;}
@Override
public void windowClosing(WindowEvent e)
	{
ConfigFileRW.writeConfigFile();
System.exit(0);
	}
private void makePanel()
	{
if(getGeneralPanel()==null)
		{
gazoushori.createGeneralPanel();
		}
if(getSubPanel()==null)
		{
gazoushori.createSubPanel();
		}
if(getImagePanel()==null)
		{
gazoushori.createImagePanel();
		}
	}
public void constracter()
	{
while(!(getGeneralPanel()!=null && getSubPanel()!=null && getImagePanel()!=null))
		{
makePanel();
		}
addGazoPanel(getGeneralPanel());
addGazoPanel(getSubPanel());
addGazoPanel(getImagePanel());
setLocationAll();
setLoopCycle(50);
System.out.println("canDispJapanese:"+GazoButton.setUseLanguage(GazoButton.UseLanguage.JAPANESE));
System.out.println(GazoButton.getDefaultFontString());
System.out.println("constracter All clear");
	}
@Override
public void firstconstracter()
	{
java.net.URL url =this.getClass().getResource("Icon.png");
try
		{
java.awt.Image icon=(javax.imageio.ImageIO.read(url));
setIconImage(icon);
		}
catch(Exception e)
		{;}
	}
public static void shori()
	{
shori(getNowShoriMode());
	}
public static SHORI_MODE getNowShoriMode()
	{
if(getGeneralPanel()!=null && getGeneralPanel().rab!=null)
		{
if(mode==null)
			{
mode=SHORI_MODE.線を引く;
			}
if(getGeneralPanel().rab.getSelection()!=mode.ordinal())
			{
mode=SHORI_MODE.valueOf(getGeneralPanel().rab.getRBTitle(getGeneralPanel().rab.getSelection()));
			}
		}
if(mode==null)
			{
mode=SHORI_MODE.線を引く;
			}
return mode;
	}
public static void shori(SHORI_MODE n)
	{
if(ip!=null && sp!=null)
		{
try
			{
Shori.shori(n);
			}
catch(Exception e)
			{
e.printStackTrace();
ip.setNewImage(ip.getNowImage());
			}
		}
	}
@Override
public void keyReleased(KeyEvent e)
 	{
super.keyReleased(e);
ShortCut.keyReleased(e);
	}
@Override
public void keyPressed(KeyEvent e)
	{
super.keyPressed(e);
ShortCut.keyPressed(e);
	}
@Override
public void keyTyped(KeyEvent e)
	{
super.keyTyped(e);
ShortCut.keyTyped(e);
	}
public void setLocationAll()
	{
System.out.println("Resize");
setExtendedState(GazoFrame.MAXIMIZED_BOTH);
gp.setBounds(0,0,getLeftPanelWidth(),getLeftPanelAboveHeight());
sp.setBounds(0,getLeftPanelAboveHeight(),getLeftPanelWidth(),getHeight()-getLeftPanelAboveHeight());
sp.setActiveSpace(0,0,sp.getWidth()-2,sp.getHeight()*2/5);
ImageCanvas.setIconImageSize(sp.getActiveSpaceWidth()/5,sp.getActiveSpaceHeight()*2/5);
sp.setMessageWindowSize(sp.getWidth(),((sp.getHeight()-sp.getActiveSpaceHeight())*1/3));
ip.setBounds(getLeftPanelWidth(),0,getWidth()-getLeftPanelWidth(),getHeight());
System.out.println("Resize OK");
	}
public int getLeftPanelWidth()
	{
return getWidth()/4;
	}
public int getLeftPanelAboveHeight()
	{
return getHeight()/2;
	}
public static String getNowImageType()
	{
return saveType;
	}
public static void setSaveImage(String str)
	{
if(saveType.equals("png") || saveType.equals("PNG") ||saveType.equals("jpg") || saveType.equals("jpeg") || saveType.equals("JPG") || saveType.equals("JPEG") || saveType.equals("gif") || saveType.equals("GIF") )
		{
saveType=str;
		}
	}
}
