/*
Copyright (C) 2017 Hayakuchi

This file is part of HinesmPaint.

HinesmPaint is free software.
You can redistribute HinesmPaint and/or modify it under the GPL Licence version3 and LGPL Licence version 3.
(GPL text and LGPL text in http://www.gnu.org/licenses/)

このプログラムはフリーソフトです。
あなたはGPLライセンスversion3及びLGPLライセンスversion3の元でこのプログラムを改変、再配布することが可能です。
(GPLとLGPLの内容は http://www.gnu.org/licenses/)にあります)
*/
package hinesm.gazoushori.special;

import java.io.File;
import java.awt.Graphics;
import java.awt.Component;
import java.awt.image.BufferedImage;
import java.awt.MediaTracker;
import javax.imageio.ImageIO;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.JFileChooser;
import hinesm.gazoushori.gazoushori;
import hinesm.gazoushori.ConfigFileRW;
import hinesm.gazoushori.ReadImage;
import hinesm.imagechenge.ImageChenge;
import hinesm.util.gazobutton.PushButton;

public final class FOButton extends PushButton
{
private ConfigFileRW.ConfigList setConfig;
private File openfile;
private BufferedImage BI[] = new BufferedImage[1];
private MediaTracker mt;
//コンストラクタ
private FOButton(Component c,int... st)
	{
super(c,st);
	}
public FOButton(String s,Component c,int... stetus)
	{
super(s,c,stetus);
	}
//openfileを取得するメソッド
public BufferedImage getImage()
	{
return getImage(0);
	}
public BufferedImage getImage(int i)
	{
if((BI!=null) && (BI.length>i))
		{
try
			{
return ImageChenge.makeNewCopyBufferedImage(BI[i]);
			}
catch(Exception e)
			{
return null;
			}
		}
else
		{
return null;
		}
	}

public File getFile()
	{
if(openfile != null)
		{
return openfile;
		}
else
		{
return null;
		}
	}
@Override
public void perform()
	{
try
		{
MediaTracker mt=new MediaTracker(this.getDependComponent());
BI=ReadImage.openReadDialog();
if(BI!=null && BI.length>0)
			{
mt.addImage(BI[BI.length-1],0);
mt.waitForID(0);
			}
		}
catch(Exception e)
		{
e.printStackTrace();
		}
if(BI!=null)
		{
gazoushori.getGeneralPanel().readOpenFile(this);
		}
	}
@Override
public void drawAny(Graphics g)
	{
if(openfile != null)
		{
g.drawString(openfile.getName(),getX(),getY()+getHeight()*7/4);
		}
super.drawAny(g);
	}
public int length()
	{
return BI.length;
	}
public boolean getLayersFlg()
	{
return ((BI!=null) && (BI.length>1));
	}
}
