/*
Copyright (C) 2017 Hayakuchi

This file is part of HinesmPaint.

HinesmPaint is free software.
You can redistribute HinesmPaint and/or modify it under the GPL Licence version3 and LGPL Licence version 3.
(GPL text and LGPL text in http://www.gnu.org/licenses/)

このプログラムはフリーソフトです。
あなたはGPLライセンスversion3及びLGPLライセンスversion3の元でこのプログラムを改変、再配布することが可能です。
(GPLとLGPLの内容は http://www.gnu.org/licenses/)にあります)
*/

package hinesm.gazoushori.special;

import java.awt.image.BufferedImage;
import hinesm.imagechenge.ImageChenge;

public class ImageCanvas
{

private int nownum=0;
public static final int UNDO_SIZE=40;
private ImageArray<BufferedImage> imageArray = new ImageArray<BufferedImage>();
private static int smallImageWidth;
private static int smallImageHeight;

private ImageArray<BufferedImage> iconImageArray = new ImageArray<BufferedImage>();
private static int iconImageWidth;
private static int iconImageHeight;

private ImageCanvas(){}
public ImageCanvas(BufferedImage bi)
	{
this();
setNewImage(bi);
	}
public void undo()
	{
setNowNum(getNowNum()-1);
	}
public void redo()
	{
setNowNum(getNowNum()+1);
	}
private void setNowNum(int n)
	{
if(0>n)
		{
nownum=0;
		}
else if(imageArray.size()<=n)
		{
nownum=imageArray.size()-1;
		}
else
		{
nownum=n;
		}
	}
public BufferedImage getIconImage()
	{
return iconImageArray.get(getNowNum());
	}
public static void setIconImageSize(int width,int height)
	{
iconImageWidth=width;
iconImageHeight=height;
	}
public static int getIconImageWidth()
	{
return iconImageWidth;
	}
public static int getIconImageHeight()
	{
return iconImageHeight;
	}
public void setNewImage(BufferedImage br)
	{
if(br!=null)
		{
setImage(ImageChenge.makeNewCopyBufferedImage(br));
		}
else
		{
setImage(null);
		}
	}
public void setImage(BufferedImage br)
	{
if(br ==null)
		{
if(getNowImage()==null)
			{
br=CanvasPanel.makeBI();
			}
else
			{
br=CanvasPanel.makeBI(getNowImage().getWidth(),getNowImage().getHeight());
			}
		}
try
		{
setImagePrivate(br);
		}
catch(IllegalArgumentException e)
		{
e.printStackTrace();
		}
	}
private void setImagePrivate(BufferedImage br)
	{
BufferedImage iconImage=ImageChenge.inFieldImage(br,getIconImageWidth(),getIconImageHeight());
if(br!=getNowImage())
		{
if(getNowNum()>=(imageArray.size()-1))
			{
if(imageArray.size()>=UNDO_SIZE)
				{
imageArray.remove(0);
iconImageArray.remove(0);
				}
imageArray.add(br);
iconImageArray.add(iconImage);
setNowNum(imageArray.size()-1);
			}
else
			{
redo();
imageArray.set(getNowNum(),br);
iconImageArray.set(getNowNum(),iconImage);
if((getNowNum()+1)<imageArray.size())
				{
imageArray.removeCanvasRange(getNowNum()+1,(imageArray.size()-1));
iconImageArray.removeCanvasRange(getNowNum()+1,(iconImageArray.size()-1));
				}
			}
		}
	}
public BufferedImage getNowImage()
	{
if(imageArray.size()>0)
		{
return imageArray.get(getNowNum());
		}
else
		{
return null;
		}
	}
public BufferedImage getNowIconImage()
	{
if(iconImageArray.size()>0)
		{
	return iconImageArray.get(getNowNum());
		}
else
		{
return null;
		}
	}
public int getNowNum()
	{
return nownum;
	}
}
