/*
Copyright (C) 2017 Hayakuchi

This file is part of HinesmPaint.

HinesmPaint is free software.
You can redistribute HinesmPaint and/or modify it under the GPL Licence version3 and LGPL Licence version 3.
(GPL text and LGPL text in http://www.gnu.org/licenses/)

このプログラムはフリーソフトです。
あなたはGPLライセンスversion3及びLGPLライセンスversion3の元でこのプログラムを改変、再配布することが可能です。
(GPLとLGPLの内容は http://www.gnu.org/licenses/)にあります)
*/

package hinesm.gazoushori.special;

import hinesm.util.UtilPerform;
import hinesm.util.gazobutton.GazoButton;
import hinesm.util.gazobutton.GazoText;
import hinesm.gazoushori.ConfigFileRW;
import hinesm.imagechenge.ImageChenge;
import java.awt.event.MouseEvent;
import java.awt.event.KeyEvent;
import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Font;
import java.awt.image.BufferedImage;

public class ManageLayerPanel extends GazoButton {

private removeLayerButton rlb;
private GazoText removeLayerNumber;

private addLayerButton alb;
private GazoText newLayerWidthText;
private GazoText newLayerHeightText;

private UpLayerButton upLayerButton;
private DownLayerButton downLayerButton;

private int ImageWindowX;
private int ImageWindowY;
private int ImageWindowWidth;
private int ImageWindowHeight;
private int ImageCellHeight;

private int ImageInsertAboveStart;
private int ImageInsertAboveEnd;
private int ImageInsertBottomStart;
private int ImageInsertBottomEnd;

private CanvasPanel tocp;

private Font noImageFont;
private String noImageString="No Image";

private BufferedImage clearIcon;
private BufferedImage clearIconOriginal;
private boolean clearIconDragging;
private int catchNumber;

private int draggingComponentsX;
private int draggingComponentsY;

private Color filterColor=new Color(0x7f000000,true);

private ManageLayerPanel(String s,Component c,int... st){super(s,c,st);}
private ManageLayerPanel(Component c,int... st){super(c,st);}

public ManageLayerPanel(Component c,CanvasPanel cp,int... st)
	{
super(c,st);
tocp=cp;
setTabUseFlg(false);
setTitleFlg(false);
int numberOfButtonRank=10;

newLayerWidthText= new GazoText("追加レイヤの幅",c,getX(),getY(),getWidth(),getHeight()/numberOfButtonRank);
newLayerHeightText= new GazoText("追加レイヤの高さ",c,newLayerWidthText.getX(),newLayerWidthText.getY()+newLayerWidthText.getHeight(),newLayerWidthText.getWidth(),newLayerWidthText.getHeight());
reloadImageSize();

alb=new addLayerButton("レイヤを追加",c,cp,newLayerWidthText,newLayerHeightText,newLayerWidthText.getX(),newLayerHeightText.getY()+newLayerHeightText.getHeight(),getWidth()/2,getHeight()/numberOfButtonRank);
rlb=new removeLayerButton("レイヤを削除",c,cp,alb.getX()+alb.getWidth(),alb.getY(),alb.getWidth(),alb.getHeight());

upLayerButton=new UpLayerButton("上",c,cp,alb.getX(),(alb.getY()+alb.getHeight()),getWidth()/6,(getHeight()-(alb.getHeight()*3))/2);
downLayerButton= new DownLayerButton("下",c,cp,upLayerButton.getX(),upLayerButton.getY()+upLayerButton.getHeight(),upLayerButton.getWidth(),upLayerButton.getHeight());

ImageWindowX=(upLayerButton.getX()+upLayerButton.getWidth());
ImageWindowY=upLayerButton.getY();
ImageWindowWidth=getWidth()-(upLayerButton.getWidth());
ImageWindowHeight=upLayerButton.getHeight()*2;

ImageCellHeight=ImageWindowHeight/3;
ImageInsertAboveStart=ImageCellHeight*4/5;
ImageInsertAboveEnd=ImageCellHeight*6/5;
ImageInsertBottomStart=ImageInsertAboveStart+ImageCellHeight;
ImageInsertBottomEnd=ImageInsertAboveEnd+ImageCellHeight;
ImageCanvas.setIconImageSize(ImageWindowWidth,ImageCellHeight);

noImageFont=new Font(Font.MONOSPACED,Font.PLAIN,UtilPerform.getFontSize(ImageWindowWidth/noImageString.length()));

this.addChildGazoButton(alb);
this.addChildGazoButton(rlb);
this.addChildGazoButton(newLayerWidthText);
this.addChildGazoButton(newLayerHeightText);
this.addChildGazoButton(upLayerButton);
this.addChildGazoButton(downLayerButton);
	}
@Override
public void perform()
	{
setTabNow(alb.getTabNum());
	}
public boolean childTabNow()
	{
return (rlb.thisTabNow() || alb.thisTabNow() || upLayerButton.thisTabNow() || downLayerButton.thisTabNow() || newLayerHeightText.thisTabNow() || newLayerWidthText.thisTabNow());
	}
@Override
public void drawAny(Graphics g)
	{
if(tocp!=null)
		{
int layernum=tocp.getNowLayerNumber();
g.setFont(noImageFont);

if(layernum>0)
			{
//bottomLayer
g.drawImage(tocp.getLayer(layernum-1).getIconImage(),ImageWindowX,ImageWindowY+ImageCellHeight*2,null);
			}
else
			{
g.drawString(noImageString,ImageWindowX,ImageWindowY+(ImageCellHeight*5/2));
			}
if(tocp.getLayerSize()>0)
			{
//centorLayer
g.drawImage(tocp.getNowLayer().getIconImage(),ImageWindowX,ImageWindowY+ImageCellHeight,null);
			}
if(layernum<(tocp.getLayerSize()-1))
			{
//aboveLayer
g.drawImage(tocp.getLayer(layernum+1).getIconImage(),ImageWindowX,ImageWindowY,null);
			}
else
			{
g.drawString(noImageString,ImageWindowX,ImageWindowY+(ImageCellHeight/2));
			}
		}

if(getClearIconDraggingFlg())
		{
g.setColor(Color.BLACK);
if(clearIcon!=null)
			{
g.drawImage(clearIcon,draggingComponentsX,draggingComponentsY,null);
g.drawRect(draggingComponentsX,draggingComponentsY,clearIcon.getWidth(),clearIcon.getHeight());
			}

if(inImageWindowWidth(draggingComponentsX))
			{
int rectHeight=ImageInsertBottomEnd-ImageInsertBottomStart;
int rectY=-100;
if(mouseCanInsertBottom(draggingComponentsY))
				{
g.drawLine(ImageWindowX,ImageWindowY+(ImageCellHeight*2),ImageWindowX+ImageWindowWidth,ImageWindowY+(ImageCellHeight*2));
rectY=ImageWindowY+ImageInsertBottomStart;
				}
else if(mouseCanInsertAbove(draggingComponentsY))
				{
g.drawLine(ImageWindowX,ImageWindowY+ImageCellHeight,ImageWindowX+ImageWindowWidth,ImageWindowY+ImageCellHeight);
rectY=ImageWindowY+ImageInsertAboveStart;
				}
if(rectY>=ImageWindowY)
				{
g.setColor(filterColor);
g.fillRect(ImageWindowX,rectY,ImageWindowWidth,rectHeight);
				}
			}
		}
else
		{
g.setColor(filterColor);
g.drawRect(ImageWindowX,ImageWindowY+ImageCellHeight,ImageWindowWidth,ImageCellHeight);
		}
	}
@Override
public void mouseDraggedPerform(MouseEvent e)
	{
draggingComponentsX=e.getX();
draggingComponentsY=e.getY();
	}
@Override
public void mouseReleasedPerform(MouseEvent e)
	{
if(getClearIconDraggingFlg())
		{
if(imageWindowsContainCheck(e.getX(),e.getY()))
			{
if(mouseCanInsertAbove(e.getY()))
				{
tocp.insertLayer(catchNumber,tocp.getNowLayerNumber()+1);
				}
else if(mouseCanInsertBottom(e.getX()))
				{
tocp.insertLayer(catchNumber,tocp.getNowLayerNumber());
				}
else if(e.getY()>ImageWindowY+(ImageCellHeight*2))
				{
if(tocp.getNowLayerNumber()>0)
					{
//右画像（ひとつ下のレイヤ）
tocp.tradeLayer(catchNumber,tocp.getNowLayerNumber()-1);
					}
				}
else if(e.getY()>ImageWindowY+ImageCellHeight)
				{
//中心画像（現在のレイヤ）
tocp.tradeLayer(catchNumber,tocp.getNowLayerNumber());
				}
else
				{
//左画像（ひとつ上のレイヤ）
if(tocp.getNowLayerNumber()<(tocp.getLayerSize()-1))
					{
tocp.tradeLayer(catchNumber,tocp.getNowLayerNumber()+1);
					}
				}
			}
clearIconDragging=false;
		}
	}
public void upLayer()
	{
upLayerButton.perform();
	}
public void downLayer()
	{
downLayerButton.perform();
	}
@Override
public void mousePressedPerform(MouseEvent e)
	{
//クリック時クリックした単体レイヤ画像のアイコン画像の半分透明の画像を作成し、マウス上に表示。(画像変数はiconClearに代入する。)
//離した位置のレイヤと入れ替える。
if(imageWindowsContainCheck(e.getX(),e.getY()))
		{
clearIconDragging=true;
perform();
if(e.getY()>ImageWindowY+(ImageCellHeight*2))
			{
//右画像（ひとつ下のレイヤ）
if(tocp.getNowLayerNumber()>0)
				{
catchNumber=tocp.getNowLayerNumber()-1;
				}
			}
else if(e.getY()>ImageWindowY+(ImageCellHeight))
			{
catchNumber=tocp.getNowLayerNumber();
			}
else
			{
//左画像（ひとつ上のレイヤ）
catchNumber=tocp.getNowLayerNumber()+1;
			}
if((tocp.getLayerSize()>catchNumber) && (catchNumber>=0) && (clearIconOriginal!=tocp.getImage(catchNumber)))
			{
clearIcon=ImageChenge.alphaPerOne(tocp.getLayer(catchNumber).getNowIconImage(),0.5);
clearIconOriginal=tocp.getImage(catchNumber);
			}

		}
	}
protected boolean getClearIconDraggingFlg()
	{
return clearIconDragging;
	}
private boolean mouseCanInsertAbove(int y)
	{
return (((ImageWindowY+ImageInsertAboveStart)<y) && (y<(ImageWindowY+ImageInsertAboveEnd)));
	}
private boolean mouseCanInsertBottom(int y)
	{
return (((ImageWindowY+ImageInsertBottomStart)<y) && (y<(ImageWindowY+ImageInsertBottomEnd)));
	}
private boolean inImageWindowWidth(int x)
	{
return (ImageWindowX<x) && (x<ImageWindowX+ImageWindowWidth);
	}
private boolean imageWindowsContainCheck(int x,int y)
	{
return ((ImageWindowX<x) &&(x<ImageWindowX+ImageWindowWidth) && inImageWindowWidth(x));
	}
public GazoButton getalb()
	{
return alb;
	}
public void reloadImageSize()
	{
newLayerWidthText.setTitle(ConfigFileRW.ConfigList.LAYER_WIDTH.toString());
newLayerHeightText.setTitle(ConfigFileRW.ConfigList.LAYER_HEIGHT.toString());
	}
}
