/*
Copyright (C) 2017 Hayakuchi

This file is part of HinesmPaint.

HinesmPaint is free software.
You can redistribute HinesmPaint and/or modify it under the GPL Licence version3 and LGPL Licence version 3.
(GPL text and LGPL text in http://www.gnu.org/licenses/)

このプログラムはフリーソフトです。
あなたはGPLライセンスversion3及びLGPLライセンスversion3の元でこのプログラムを改変、再配布することが可能です。
(GPLとLGPLの内容は http://www.gnu.org/licenses/)にあります)
*/

package hinesm.gazoushori.special;

import java.awt.Component;
import java.awt.event.MouseEvent;
import java.awt.event.KeyEvent;
import hinesm.util.gazobutton.GazoButton;
import hinesm.util.gazobutton.GazoText;
import hinesm.util.gazobutton.ScrollBar;

public class NuriControlPanel extends GazoButton
{
private ScrollBar nuriBar;
private GazoText barValue;
private GazoButton infoNuri;
private boolean dragging;
private int nuriBorder=0;

private NuriControlPanel(String s,Component c,int... st){super(s,c,st);}
public NuriControlPanel(Component c,int... status)
	{
super("",c,status);
nuriBar=new ScrollBar(getX(),getY()+(getHeight()/2),getHeight()/2,getWidth(),ScrollBar.MODE_HORIZONTAL,255+getWidth(),c);
barValue=new GazoText("塗り境界の曖昧さ(0~255)",c,getX(),getY(),getWidth(),getHeight()/2,3);
barValue.setTitle("0");
addChildGazoButton(nuriBar);
addChildGazoButton(barValue);
	}
public int nuriAllowNum()
	{
if(barValue!=null)
		{
try
			{
return Integer.parseInt(barValue.getTitle());
			}
catch(Exception e)
			{
return 0;
			}
		}
else
		{
return 0;
		}
	}
@Override
public void usualPerform()
	{
if(dragging)
		{
barValue.setTitle(String.valueOf(nuriBar.getLocate()*255/(getWidth()+255)));
		}
	}
@Override
public void keyReleasedPerform(KeyEvent e)
	{
if(barValue!=null && barValue.thisTabNow())
		{
try
			{
nuriBar.setBarButtonLocation((Integer.parseInt(barValue.getTitle())*(getWidth()+255))/255,true);
			}
catch(Exception ex)
			{
nuriBar.setBarButtonLocation(0,true);
			}
		}
	}
@Override
public void mouseReleasedPerform(MouseEvent e)
	{
super.mouseReleasedPerform(e);
dragging=false;
	}
@Override
public void mousePressedPerform(MouseEvent e)
	{
super.mousePressedPerform(e);
if((nuriBar!=null))
		{
if(nuriBar.containCheck(e.getX(),e.getY()))
			{
dragging=true;
			}
		}
	}
@Override
public void perform()
	{;}
}
