/*
Copyright (C) 2017 Hayakuchi

This file is part of HinesmPaint.

HinesmPaint is free software.
You can redistribute HinesmPaint and/or modify it under the GPL Licence version3 and LGPL Licence version 3.
(GPL text and LGPL text in http://www.gnu.org/licenses/)

このプログラムはフリーソフトです。
あなたはGPLライセンスversion3及びLGPLライセンスversion3の元でこのプログラムを改変、再配布することが可能です。
(GPLとLGPLの内容は http://www.gnu.org/licenses/)にあります)
*/
package hinesm.gazoushori.special;

import hinesm.util.UtilPerform;
import hinesm.util.gazobutton.GazoButton;
import hinesm.util.gazobutton.RadioButton;
import hinesm.gazoushori.gazoushori;
import hinesm.gazoushori.ConfigFileRW;
import hinesm.imagechenge.ImageChenge;
import java.awt.Component;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.io.File;
import javax.imageio.ImageIO;

public class SPSubImage extends GazoButton
{
	
ImageCanvas ic;
int suby;
int subWidth;
int subHeight;
int radioy;
int radioWidth;
int radioHeight;
int stringx;
int stringy;
Font stringFont;
BufferedImage subimg;
BufferedImage viewImg;
RadioButton itradio;

private SPSubImage(String s,Component c,int... st)
	{
super(s,c,st);
	}
public SPSubImage(Component c,int... st)
	{
super(c,st);
setTitleFlg(false);
setTabUseFlg(false);
stringFont=new Font(GazoButton.getDefaultFontString(),Font.PLAIN,getFontSize());
File file = new File(ConfigFileRW.ConfigList.SUB_IMAGE.toString());
if(file.exists())
		{
try
			{
setSubImage(ImageIO.read(file));
			}
catch(Exception e)
			{
setSubImage(null);
			}
		}
else
		{
setSubImage(null);
		}
setViewBounds();
	}

@Override
public void drawAny(Graphics g)
	{
g.setColor(Color.black);
g.setFont(stringFont);
g.drawString("補助画像",stringx,stringy);
if(itradio==null)
		{
setViewBounds();
itradio= new RadioButton("補助画像描画方式",this.getDependComponent(),getX(),radioy,radioWidth,radioHeight,2,"画面に合わせて拡大","繰り返し");
addChildGazoButton(itradio);
		}
if((subimg!=null) && (viewImg!=null))
		{
g.drawImage(viewImg,stringx,suby,null);
		}
else
		{
g.drawString("補助画像設定なし",getX(),getY()+getHeight()/2);
		}
	}
public void setSubImage(BufferedImage bi)
	{
setViewBounds();
if(bi!=null)
		{
subimg=ImageChenge.makeNewCopyBufferedImage(bi);
viewImg=ImageChenge.inFieldImage(bi,subWidth,subHeight);
		}
	}
public BufferedImage getSubImage()
	{
return subimg;
	}
public int getSubImageMode()
	{
if(itradio!=null)
		{
return itradio.getSelection();
		}
else
		{
return 0;
		}
	}
private int getFontSize()
	{
return UtilPerform.getFontSize(Math.min((getWidth()/("補助画像設定なし".length())),(getHeight()/5)));
	}
private void setViewBounds()
	{
stringx=getX()+1;
stringy=getY()+getHeight()/10+getFontSize()/2;
suby=stringy+getFontSize()/2;
subWidth=getWidth()+getX()-stringx;
subHeight=getHeight()/2;
radioy=suby+subHeight;
radioWidth=getWidth();
radioHeight=getY()+getHeight()-radioy;
	}
@Override
public void perform()
	{;}
}
