/*
Copyright (C) 2017 Hayakuchi

This file is part of HinesmPaint.

HinesmPaint is free software.
You can redistribute HinesmPaint and/or modify it under the GPL Licence version3 and LGPL Licence version 3.
(GPL text and LGPL text in http://www.gnu.org/licenses/)

このプログラムはフリーソフトです。
あなたはGPLライセンスversion3及びLGPLライセンスversion3の元でこのプログラムを改変、再配布することが可能です。
(GPLとLGPLの内容は http://www.gnu.org/licenses/)にあります)
*/

package hinesm.imagechenge;

import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.File;
import java.util.ArrayList;

public class ImageChenge
{
	
public static final boolean CIRCLE_DELTA_WIDTH = true;
public static final boolean CIRCLE_DELTA_HEIGHT = false;

public static final int LINE_SQUARE=0;
public static final int LINE_SQUARE_ANTI_ALIAS=1;
public static final int LINE_ROUND=2;
public static final int LINE_ROUND_ANTI_ALIAS=3;

public static final int NURI_NORMAL=0;
public static final int NURI_OVERLAY=1;
public static final int NURI_OVERLAY_REPEAT=2;
public static final int NURI_TEXTURE=3;
public static final int NURI_TEXTURE_REPEAT=4;

public static final int RESIZE_SINPLE=0;
public static final int RESIZE_GAUSS=1;
public static final int RESIZE_REPEAT=2;

public static final int REVERSE_HORIZONTAL=1;
public static final int REVERSE_PERPENDICULAR=2;
public static final int REVERSE_HORIZONTAL_AND_PERPENDICULAR=3;

private static StringBuilder cCSB=new StringBuilder("#ffffffff");

public static void main(String[] args)
	{
BufferedImage bi;
try
		{
bi = ImageIO.read(new File("../../testSpace/HinesmPaint/whiteImage.png"));
System.out.println("readed");
fillCircle(bi,bi.getWidth()/2,bi.getHeight()/2,6,0xffff0000,true);
drawCircle(bi,bi.getWidth()/2,bi.getHeight()/2,6,0xffff0000);
System.out.println("writed");
ImageIO.write(bi,"png",new File("../../testSpace/HinesmPaint/afterTest.png"));
System.out.println("transed");
		}
catch(Exception e)
		{
e.printStackTrace();
		}
System.out.println("end");
	}

private ImageChenge()
{}
/**
引数となったBufferedImageインスタンスと同じ幅、高さを持ち、それぞれ同じARGB値を持ったBufferedImageインスタンスを新たに作成し、そのインスタンスを戻り値として返します。
*/
public static BufferedImage makeNewCopyBufferedImage(BufferedImage bi)
	{
BufferedImage newImage = new BufferedImage(bi.getWidth(),bi.getHeight(),BufferedImage.TYPE_INT_ARGB);
for(int x=0;bi.getWidth()>x;x++)
		{
for(int y=0;bi.getHeight()>y;y++)
			{
newImage.setRGB(x,y,bi.getRGB(x,y));
			}
		}
return newImage;
	}
public static BufferedImage inFieldImage(BufferedImage bi,int width,int height)
	{
boolean baseWidth=height>bi.getHeight()*width/bi.getWidth();
if(baseWidth)
			{
/*
横基準倍率
*/
return getNewSizeImage(bi,width,bi.getHeight()*width/bi.getWidth(),RESIZE_SINPLE);
			}
else
			{
/*横基準倍率*/
return getNewSizeImage(bi,bi.getWidth()*height/bi.getHeight(),height,RESIZE_SINPLE);
			}
	}
/**
引数となったBufferedImageインスタンスの全ての画素のアルファチャンネルをafterAlphaに変更した新しいBufferedImageインスタンスを戻り値とするメソッドです。
*/

public static BufferedImage imageToClear(BufferedImage bi,int afterAlpha)
	{
BufferedImage newbi = makeNewCopyBufferedImage(bi);
int alpha=afterAlpha;
if(alpha>255)
		{	alpha=255;	}
if(alpha<0)
		{	alpha=0;	}
alpha=alpha<<24;
for(int x=0;bi.getWidth()>x;x++)
		{
for(int y=0;bi.getHeight()>y;y++)
			{
newbi.setRGB(x,y,(((newbi.getRGB(x,y)<<8)>>>8)+alpha));
			}
		}
return newbi;
	}
public static BufferedImage alphaPerOne(BufferedImage bi,double magnification)
	{
BufferedImage ret = makeNewCopyBufferedImage(bi);
for(int x=0;x<ret.getWidth();x++)
		{
for(int y=0;y<ret.getHeight();y++)
			{
int dAlpha=(int)(((double)(ret.getRGB(x,y)>>>24))*magnification);
if(dAlpha>255)
				{
dAlpha=255;
				}
else if(0>dAlpha)
				{
dAlpha=0;
				}
dAlpha=dAlpha<<24;
ret.setRGB(x,y,((ret.getRGB(x,y)<<8)>>>8)+dAlpha);
			}
		}
return ret;
	}
public static BufferedImage jouzan(BufferedImage underImage,BufferedImage onImage)
	{
try
		{
BufferedImage motoue=onImage;
BufferedImage motosita=underImage;
BufferedImage kekka = new BufferedImage(motosita.getWidth(),motosita.getHeight(),3);
int x=0;
int y=0;
int coln;
int sC;
while(kekka.getWidth()>x)
			{
y=0;
while(kekka.getHeight()>y)
				{
if(x<motoue.getWidth() && y<motoue.getHeight())
					{
coln=0;
sC=0;
while(coln<4)
						{
sC=sC+(((((motoue.getRGB(x,y)>>>(coln*8))<<24>>>24)*((motosita.getRGB(x,y)>>>(coln*8))<<24>>>24))/255)<<(coln*8));
coln=coln+1;
						}
kekka.setRGB(x,y,sC);
					}
else
					{
kekka.setRGB(x, y, motosita.getRGB(x, y));
					}
y=y+1;
				}
x=x+1;
			}
return kekka;
		}
catch(Exception e)
		{
System.out.println(e);
		}
return null;
	}

public static BufferedImage scr(BufferedImage underImage,BufferedImage onImage)
	{
try
		{
BufferedImage motoue=onImage;
BufferedImage motosita=underImage;
BufferedImage kekka = new BufferedImage(motosita.getWidth(),motosita.getHeight(),3);
int coln;
int rC;
for(int x=0;kekka.getWidth()>x;x++)
			{
for(int y=0;kekka.getHeight()>y;y++)
				{
if(x<motoue.getWidth() && y<motoue.getHeight())
					{
coln=0;
rC=0;
while(coln<4)
						{
rC=rC+((255-(((255-((motoue.getRGB(x,y)>>>(coln*8))<<24>>>24))*(255-((motosita.getRGB(x,y)>>>(coln*8))<<24>>>24)))/255))<<(coln*8));
coln=coln+1;
						}
					}
else
					{
rC=motosita.getRGB(x, y);	
					}
kekka.setRGB(x,y,rC);
				}
			}
return kekka;
		}
catch(Exception e)
		{
System.out.println(e);
		}
return null;
	}
public static BufferedImage overlay(BufferedImage underImage,BufferedImage onImage)
	{
int width=underImage.getWidth();
int height=underImage.getHeight();
BufferedImage ret = new BufferedImage(width,height,BufferedImage.TYPE_INT_ARGB);
for(int x=0;x<width;x++)
		{
for(int y=0;y<height;y++)
			{
if(x<onImage.getWidth() && y<onImage.getHeight())
				{
ImageChenge.overlaySetRGB(ret,underImage,onImage,x,y);
				}
else
				{
ret.setRGB(x,y,underImage.getRGB(x, y));
				}
			}
		}
return ret;
	}
//bcol is 'brefore color'
//acol is 'after color'
public static BufferedImage henkan(int bcol,int acol,BufferedImage img)
	{
try
		{
for(int x=0;x<(img.getWidth());x++)
			{
for(int y=0;y<(img.getHeight());y++)
				{
if((img.getRGB(x,y))==bcol)
					{
img.setRGB(x,y,acol);
					}
				}
			}
		}
catch(Exception e)
		{
System.out.println(e);
		}
return img;
	}

private static int colorFullTrans(String s)
	{
int color=0;
int num = s.length();
if(num>8)
		{
num=8;
		}
int fbit=0;
for(int cou=1;num>=cou;cou++)
		{
switch(s.charAt(num-cou))
			{
case '0':
case '０':
fbit=0;
break;
case '1':
case '１':
fbit=1;
break;
case '2':
case '２':
fbit=2;
break;
case '3':
case '３':
fbit=3;
break;
case '4':
case '４':
fbit=4;
break;
case '5':
case '５':
fbit=5;
break;
case '6':
case '６':
fbit=6;
break;
case '7':
case '７':
fbit=7;
break;
case '8':
case '８':
fbit=8;
break;
case '9':
case '９':
fbit=9;
break;
case 'A':
case 'a':
case 'Ａ':
case 'ａ':
fbit=10;
break;
case 'B':
case 'b':
case 'Ｂ':
case 'ｂ':
fbit=11;
break;
case 'C':
case 'c':
case 'Ｃ':
case 'ｃ':
fbit=12;
break;
case 'D':
case 'd':
case 'Ｄ':
case 'ｄ':
fbit=13;
break;
case 'E':
case 'e':
case 'Ｅ':
case 'ｅ':
fbit=14;
break;
default:
fbit=15;
break;
			}
for(int bcou=1;bcou<cou;bcou++)
			{
fbit=fbit*16;
			}
color=color+fbit;
		}
return color;
	}
public static int colorTrans(String s)
	{
int retcol = 0xffffffff;
if(s.charAt(0)=='#')
		{
cCSB.replace(0,cCSB.length(),s.substring(1,s.length()));
		}
else
		{
cCSB.replace(0,cCSB.length(),s);
		}
if(cCSB.length()==6)
		{
cCSB = cCSB.insert(0,"ff");
		}
retcol=colorFullTrans(cCSB.toString());
return retcol;
	}
public static boolean canColorTrans(String s)
	{
boolean canflg=true;
int addpoint = 0;
if(s.charAt(0)=='#')
		{
addpoint=1;
		}
if(!(((s.length()-addpoint)==6) ||((s.length()-addpoint)==8)))
		{
return false;
		}
for(int cou=addpoint;cou<s.length();cou++)
		{
switch(s.charAt(cou))
			{
case '1':
case '１':
case '2':
case '２':
case '3':
case '３':
case '4':
case '４':
case '5':
case '５':
case '6':
case '６':
case '7':
case '７':
case '8':
case '８':
case '9':
case '０':
case '0':
case 'A':
case 'a':
case 'Ａ':
case 'ａ':
case 'B':
case 'b':
case 'Ｂ':
case 'ｂ':
case 'C':
case 'c':
case 'Ｃ':
case 'ｃ':
case 'D':
case 'd':
case 'Ｄ':
case 'ｄ':
case 'E':
case 'e':
case 'Ｅ':
case 'ｅ':
case 'F':
case 'f':
case 'Ｆ':
case 'ｆ':
break;
default:
canflg=false; 
break;
			}
		}
return canflg;
	}
public static BufferedImage drawCircle(BufferedImage bi,int... stat)
	{
/*
stat[0]=x
stat[1]=y
stat[length-1]=color
*/
switch(stat.length)
		{
case 4:
//stat[3]=radius
return drawCircle(bi,stat[0],stat[1],stat[2],stat[2],1,1,1,stat[3],true);
case 5:
//stat[2]=width
//stat[3]=height
return drawCircle(bi,stat[0],stat[1],stat[2],stat[3],1,1,1,stat[4],true);
case 6:
//stat[2]=radius
//stat[3]=kaisuu
//stat[4]=kakuchouradius
return drawCircle(bi,stat[0],stat[1],stat[2],stat[2],stat[3],stat[4],stat[4],stat[5],true);
case 8:
//stat[2]=width
//stat[3]=height
//stat[4]=kaisuu
//stat[5]=kukuchouwid
//stat[6]=kakuchouhei
return drawCircle(bi,stat[0],stat[1],stat[2],stat[3],stat[4],stat[5],stat[6],stat[7],true);
default:
return null;
		}
	}
public static BufferedImage drawThought(BufferedImage bi,int X,int Y,int width,int height,int range,int kosa,boolean rangetype)
	{
int sx=0;
int sy=0;
boolean nukenflg=true;
if(kosa<1)
		{
kosa=1;
		}
if(width==0)
		{
width=1;
		}
if(height==0)
		{
height=1;
		}
//(sx-X)^2/width^2i+(sy-Y)^2/height^2=1; NormalOval
//sy=r(height*height*(1-(sx-X)^2)/width^2)+Y;
//sy'=height*(sx-X)/(r(1-((sx-X)^2/width^2))*(width^2));OvalBibun
int cou=0;
int esx=X+width;
int esy=Y+height;
int kaisuuhei=1;
double sizeper=1;
if(rangetype)
		{
sizeper = (((double)(width+range))/width);
kaisuuhei = ((int)((double)height*sizeper))-height;
		}
else
		{
kaisuuhei=range;
sizeper=(((double)(height+kaisuuhei))/height);
range=((int)((double)width*sizeper))-width;
		}
/*
double katamuki=0;
*/
int sqrt=0;
while(kosa>=cou)
		{
double tan = Math.tan((Math.PI/kosa)*cou);
nukenflg=true;
if(0.5==((double)cou/(double)kosa))
			{
privateDrawLine(bi,X,Y+height,X,Y+(height+kaisuuhei));
privateDrawLine(bi,X,Y-height,X,Y-(height+kaisuuhei));
			}
else if((-0.0==((double)cou/(double)kosa)) || (((double)cou/(double)kosa)==0.0))
			{
privateDrawLine(bi,X+width,Y,X+(width+range),Y);
privateDrawLine(bi,X-width,Y,X-(width+range),Y);
			}
else if(Math.abs(tan)>=1.0)
			{
sx=X-width;
esx=X+width;
while((sx<esx) && nukenflg)
				{
double sxXsa=((double)(sx-X));
//if((Math.abs(height*(sx-X)/(width*width*Math.sqrt(1.0-((sx-X)*(sx-X)/(width*width)))))<=circlebibun) && (circlebibun<=(Math.abs(height*(sx+1-X)/(width*width*Math.sqrt(1.0-((sx+1-X)*(sx+1-X)/(width*width))))))))
try
					{
if((height*Math.sqrt(1.0-((sxXsa*sxXsa)/(width*width)))/(X-sx))<=tan && tan<=(height*Math.sqrt(1.0-((sxXsa+1.0)*(sxXsa+1.0)/(width*width)))/(X-sx)))
						{
sqrt=(int)(height*(Math.sqrt((1.0-(sxXsa*sxXsa/(width*width))))));
privateDrawLine(bi,sx,Y+sqrt,(int)(X+(sxXsa*sizeper)),(int)(Y+(sqrt*sizeper)));
privateDrawLine(bi,sx,Y-sqrt,(int)(X+(sxXsa*sizeper)),(int)(Y-(sqrt*sizeper)));
nukenflg=false;
						}
					}
catch(Exception e)
					{
					}
sx=sx+1;
				}
			}
else
			{
sy=Y-height;
esy=Y+height;
while(sy<esy && nukenflg)
				{
double syYsa=sy-Y;
//if((Math.abs(width*(sy-Y)/(height*height*Math.sqrt(1-((sy-Y)*(sy-Y)/(height*height)))))<=tan) && (tan<=(Math.abs(width*(sy+1-Y)/(height*height*Math.sqrt(1-((sy+1-Y)*(sy+1-Y)/(height*height))))))))
try
					{
/*
syYsa+1katamuki<tan<syYsakatamuki
*/
if(((syYsa/(width*Math.sqrt(1.0-(syYsa*syYsa/(height*height)))))<=tan) && (tan<=((syYsa+1.0)/(width*Math.sqrt(1.0-((syYsa+1.0)*(syYsa+1.0)/(height*height)))))))
						{
sqrt=(int)(width*Math.sqrt(1.0-(syYsa*syYsa/(height*height))));
privateDrawLine(bi,X+sqrt,sy,(int)(X+(sqrt*sizeper)),(int)(Y+(syYsa*sizeper)));
privateDrawLine(bi,X-sqrt,sy,(int)(X-(sqrt*sizeper)),(int)(Y+(syYsa*sizeper)));
nukenflg=false;
						}
					}
catch(Exception e)
					{
					}
sy=sy+1;
				}
			}
cou=cou+1;
		}
return bi;
	}
private static void privateDrawLine(BufferedImage bi,int startx,int starty,int endx,int endy)
	{
drawLine(bi,startx,starty,endx,endy,DrawLineInfo.DEFAULT);
	}
/**
引数となったBufferedImageに直接intと同じ色の直線を引く破壊的メソッドです。
*/
public static void drawLine(BufferedImage bi,int startx,int starty,int endx,int endy,DrawLineInfo info)
	{
DrawLine.drawLine(bi,startx,starty,endx,endy,info);
	}
public static void drawThickLine(BufferedImage bi,int startx,int starty,int endx,int endy,DrawLineInfo info)
	{
if((info!=null) && (info.getThick()>1))
		{
DrawLine.drawThickLine(bi,startx,starty,endx,endy,info);
		}
else
		{
DrawLine.drawLine(bi,startx,starty,endx,endy,DrawLineInfo.DEFAULT);
		}
	}
public static void drawAntiAliasLine(BufferedImage bi,int startx,int starty,int endx,int endy,DrawLineInfo info)
	{
if((info!=null) && (info.getThick()>1))
		{
DrawLine.drawAntiAliasLine(bi,startx,starty,endx,endy,info);
		}
else
		{
DrawLine.drawLine(bi,startx,starty,endx,endy,DrawLineInfo.DEFAULT);
		}
	}
public static BufferedImage fillCircle(BufferedImage bi,int X,int Y,int range,int color,boolean antialias)
	{
return fillCircle(bi,X,Y,range,range,color,antialias);
	}
public static BufferedImage fillCircle(BufferedImage bi,int X,int Y,int range,int color)
	{
return fillCircle(bi,X,Y,range,range,color,false);
	}
public static BufferedImage fillCircle(BufferedImage bi,int X,int Y,int height,int width,int color)
	{
return fillCircle(bi,X,Y,width,height,color,false);
	}
public static BufferedImage fillCircle(BufferedImage bi,int X,int Y,int width,int height,int color,boolean antialias)
	{
width=Math.abs(width);
height=Math.abs(height);
long hw=height*width;
if(hw!=0)
		{
long al=(long)(color>>>24);//antialias==trueのときしか使わない
int startX=X-width;
if(startX<0)
			{
startX=0;
			}
int lastX=X+width;
if(lastX>bi.getWidth())
			{
lastX=bi.getWidth();
			}
for(int x=startX;x<lastX;x++)
			{
int dx=x-X;
int lastY=((int)(Math.sqrt((height*height)-(((height*height)*(dx*dx))/(width*width)))))+Y;
if(lastY>bi.getHeight())
				{
lastY=bi.getHeight();
				}
int startY=Y+Y-lastY;//Y-(lastY-Y)の変形
if(startY<0)
				{
startY=0;
				}
long rx=dx*height;//antialias==trueの時しか使わない
for(int y=startY;y<lastY;y++)
				{
int dy=y-Y;
if(antialias)
					{
long ry=dy*width;
int alpha=((color>>>24)-(((int)(Math.sqrt((al)*(al)*((rx*rx)+(ry*ry))/(hw*hw))))))<<24;
bi.setRGB(x,y,getOverlayARGB(bi.getRGB(x,y),alpha+((color<<8)>>>8)));
					}
else
					{
bi.setRGB(x,y,getOverlayARGB(bi.getRGB(x,y),color));
					}
				}
			}
		}
return bi;
	}
public static BufferedImage drawCircle(BufferedImage bi,int X,int Y,int width,int height,int kaisuu,int kankakuwid,int kankakuhei,int color,boolean rangetype)//x,yは中心位置、width,heightは半径
	{
int x=0;
int y=0;
//楕円を描く処理

if(kaisuu<1)
		{
kaisuu=1;
		}
if(kankakuhei<1 || kankakuwid<1)
		{
kaisuu=1;
		}
int cou=0;
while(kaisuu>cou)
		{
int wid=width+(kankakuwid*cou);
int hei=height+(kankakuhei*cou);
double WIDTHnijo=wid*wid;
double HEIGHTnijo=hei*hei;
/*本来はx=X-(width+kankakuwid*kaisuu)とするところだが、
この変数代入の仕方にすることで
y=+-r((1-(x-X)^2/width^2)*height^2)+Yをy=+-r((1-x^2/width^2)*height^2)+Yとし、
setRGB(x,y,color)をsetRGB(x+X,y,color)と
することが出来るので、計算回数が少し少なく済むようになる
*/
x=-1*wid;
y=0;
while(x<wid)
			{
//x^2/a^2+y^2/b^2=1
//y=+-r((1-x^2/a^2)*b^2)+Y
y=(int)(Math.sqrt(HEIGHTnijo-(x*x*HEIGHTnijo/WIDTHnijo)))+Y;
if(x+X>=0 && y>=0 && x+X<bi.getWidth() && y<bi.getHeight())
				{
bi.setRGB(x+X,y,color);
				}
//根号は正負反転する。ただしY位置は根号の範囲外なのでY位置を2回足し、正の数に直す
y=(y*(-1))+Y+Y;
if(x+X>=0 && y>=0 && x+X<bi.getWidth() && y<bi.getHeight())
				{
bi.setRGB(x+X,y,color);
				}
x=x+1;
			}

x=0;
y=-1*hei;
while(y<hei)
			{
x=(int)(Math.sqrt(WIDTHnijo-(y*y*WIDTHnijo/HEIGHTnijo)))+X;
if(x>=0 && y+Y>=0 && x<bi.getWidth() && y+Y<bi.getHeight())
				{
bi.setRGB(x,y+Y,color);
				}
x=(x*(-1))+X+X;
if(x>=0 && y+Y>=0 && x<bi.getWidth() && y+Y<bi.getHeight())
				{
bi.setRGB(x,y+Y,color);
				}
y=y+1;
			}
cou=cou+1;
		}
return bi;
	}
public static int getColorMean(int... color)
	{
int colsum = 0;//a,r,g,b
int ret=0;
for(int cou=0;4>cou;cou++)
		{
colsum=0;
for(int scou=0;color.length>scou;scou++)
			{
colsum=colsum+((color[scou]<<(cou*8))>>>24);
			}
colsum=colsum/color.length;
ret = ret+(colsum<<(24-(cou*8)));
		}
return ret;
	}

public static BufferedImage getNewSizeImage(BufferedImage bi,int width,int height,int mode)
	{
if(!(bi.getWidth()==width && bi.getHeight()==height))
		{
switch(mode)
			{
case RESIZE_SINPLE:
return getNewSizeImageNormal(bi,width,height);
case RESIZE_REPEAT:
return getNewSizeImageRepeat(bi,width,height);
default:
return getNewSizeImageGauss(bi,width,height);
			}
		}
return makeNewCopyBufferedImage(bi);
	}
private static BufferedImage getNewSizeImageGauss(BufferedImage bi,int width,int height)
	{
BufferedImage ret = getNewSizeImageNormal(bi,width,height);
double newimgperimgwidth = (double)ret.getWidth()/(double)bi.getWidth(); 
double imgpernewimgwidth = (double)bi.getWidth()/(double)ret.getWidth();
double newimgperimgheight = (double)ret.getHeight()/(double)bi.getHeight(); 
double imgpernewimgheight = (double)bi.getHeight()/(double)ret.getHeight();
int mcolx=(int)(newimgperimgwidth)+1;
int sizetype=3;
if(newimgperimgwidth<1)
				{
mcolx=(int)(imgpernewimgwidth)+1;
sizetype=sizetype-1;
				}
int mcoly=(int)(newimgperimgheight)+1;
if(newimgperimgheight<1)
				{
mcoly=(int)(imgpernewimgheight)+1;
sizetype=sizetype-2;
				}
//サイズ表
int[] meancolarray = new int[mcolx*mcoly];
int mx=0;
int my=0;
for(int x=0;width>x;x++)
				{
for(int y=0;height>y;y++)
					{
mx=0;
while(mcolx>mx)
						{
my=0;
while(mcoly>my)
							{
int elementx=0;
int elementy=0;
switch(sizetype)
								{
case 0:
//0:縦横縮小
elementx=(int)((double)x*imgpernewimgwidth)+mx;
if(elementx>=bi.getWidth())
				{	elementx=bi.getWidth()-1;	}
elementy=(int)((double)y*imgpernewimgheight)+my;
if(elementy>=bi.getHeight())
				{	elementy=bi.getHeight()-1;	}
meancolarray[(mx*mcoly)+my] = bi.getRGB(elementx,elementy);
break;
case 1:
//1:縦縮小横拡大
elementx=(int)((double)x*imgpernewimgwidth)+mx;
if(elementx>=bi.getWidth())
				{	elementx=bi.getWidth()-1;	}
elementy=(int)((double)y*imgpernewimgheight)+my;
if(elementy>=bi.getHeight())
				{	elementy=bi.getHeight()-1;	}

meancolarray[(mx*mcoly)+my] = bi.getRGB(elementx,elementy);
break;
case 2:
//2;縦拡大横縮小
elementx=(int)((double)x*imgpernewimgwidth)+mx;
if(elementx>=bi.getWidth())
				{	elementx=bi.getWidth()-1;	}
elementy=(int)((double)y*imgpernewimgheight)+my;
if(elementy>=bi.getHeight())
				{	elementy=bi.getHeight()-1;	}
meancolarray[(mx*mcoly)+my] = bi.getRGB(elementx,elementy);
break;
default:
//3:縦横拡大
elementx=x+mx;
if(ret.getWidth()<=elementx)
				{	elementx=ret.getWidth()-1;	}
elementy=y+my;
if(ret.getHeight()<=elementy)
				{	elementy=ret.getHeight()-1;	}
meancolarray[(mx*mcoly)+my] = ret.getRGB(elementx,elementy);
break;
								}

my=my+1;
							}
mx=mx+1;
						}
ret.setRGB(x,y,getColorMean(meancolarray));
					}
				}
return ret;
	}
private static BufferedImage getNewSizeImageRepeat(BufferedImage bi,int width,int height)
	{
BufferedImage ret = new BufferedImage(width,height,BufferedImage.TYPE_INT_ARGB);
for(int x=0;ret.getWidth()>x;x++)
			{
for(int y=0;ret.getHeight()>y;y++)
				{
ret.setRGB(x,y,bi.getRGB((x%bi.getWidth()),(y%bi.getHeight())));
				}
			}
return ret;
	}

private static BufferedImage getNewSizeImageNormal(BufferedImage bi,int width,int height)
	{
BufferedImage ret = new BufferedImage(width,height,BufferedImage.TYPE_INT_ARGB);
double imgpernewimgwidth = (double)bi.getWidth()/(double)ret.getWidth();
double imgpernewimgheight = (double)bi.getHeight()/(double)ret.getHeight();
int bix=0;
int biy=0;

for(int x=0;width>x;x++)
				{
for(int y=0;height>y;y++)
					{
bix=(int)((double)x*imgpernewimgwidth);
if(bix < 0)
						{
bix=0;
						}
else if(bix >= bi.getWidth())
						{
bix=bi.getWidth()-1;	}
biy=(int)((double)y*imgpernewimgheight);
if(biy<0)
						{
biy=0;
						}
else if(biy>=bi.getHeight())
						{
biy=bi.getHeight()-1;
						}
ret.setRGB(x,y,bi.getRGB(bix,biy));
					}
				}
return ret;
	}


public static BufferedImage nuriTubusi(BufferedImage img,int x,int y,int afterColor,int mode)
	{
return nuriTubusi(img,x,y,afterColor,mode,0);
	}
public static BufferedImage nuriTubusi(BufferedImage img,int x,int y,int afterColor,int mode,int border)
	{
return nuriTubusi(img,img,x,y,afterColor,mode,border);
	}
public static BufferedImage nuriTubusi(BufferedImage img,BufferedImage onimg,int x,int y,int mode)
	{
return nuriTubusi(img,onimg,x,y,mode,0);
	}
public static BufferedImage nuriTubusi(BufferedImage img,BufferedImage onimg,int x,int y,int mode,int border)
	{
return nuriTubusi(img,onimg,x,y,0xffffffff,mode,border);
	}
public static BufferedImage nuriTubusi(BufferedImage img,BufferedImage onimg,int x,int y,int afterColor,int mode,int nuriBorder)
	{
if(img!=null)
		{
int beforeCol=img.getRGB(x,y);
NuriInfo ni = new NuriInfo(img.getWidth(),img.getHeight(),afterColor,mode,nuriBorder);
BufferedImage aimg = makeNewCopyBufferedImage(img);
BufferedImage aonimg;
if(onimg==null)
			{
aonimg=makeNewCopyBufferedImage(img);
			}
else
			{
switch(mode)
				{
case NURI_TEXTURE_REPEAT:
case NURI_OVERLAY_REPEAT:
aonimg = getNewSizeImage(onimg,img.getWidth(),img.getHeight(),RESIZE_REPEAT);
break;
case NURI_TEXTURE:
case NURI_OVERLAY:
default:
aonimg = getNewSizeImage(onimg,img.getWidth(),img.getHeight(),RESIZE_GAUSS);
break;
				}
			}
if(aimg!=null && aonimg!=null)
			{
protNuriTubusiY(aimg,aonimg,x,y,beforeCol,1,ni);
			}
return aimg;
		}
return null;
	}
/*
指定された位置を塗り替えるかの判定
*/
private static boolean nuriHantei(BufferedImage bi,BufferedImage onimg,int x,int y,int beforeCol,NuriInfo ni)
	{
switch(ni.getMode())
		{
case NURI_NORMAL:
case NURI_OVERLAY:
case NURI_OVERLAY_REPEAT:
case NURI_TEXTURE:
case NURI_TEXTURE_REPEAT:
return (bi.getWidth()>x) && (bi.getHeight()>y) && (!(ni.getFinish(x,y))) && (ni.getBorder()>=colorsDelta(beforeCol,bi.getRGB(x,y)));
default:
;
		}
return false;
	}
private static int colorsDelta(int color1,int color2)
	{
int ret=0;
for(int c=0;c<4;c++)
		{
int movebit=8*c;
ret=Math.max(ret,Math.abs(((color2<<movebit)>>>24)-((color1<<movebit)>>>24)));
		}
return ret;
	}
/*指定された場所まで捜索して、塗りつぶしの再帰処理を終了するかの判定。trueなら続ける、falseならおしまい*/
private static boolean nuriDoHantei(BufferedImage bi,BufferedImage onimg,int x,int y,int beforeCol,NuriInfo ni)
	{
return !(ni.getFinish(x,y));
	}
/*指定された位置を塗り替える*/
private static void nuriSetRGB(BufferedImage bi,BufferedImage onbi,int x,int y,int beforeCol,NuriInfo ni)
	{
switch(ni.getMode())
		{
case NURI_OVERLAY:
case NURI_OVERLAY_REPEAT:
overlaySetRGB(bi,bi,onbi,x,y);
break;
case NURI_TEXTURE:
case NURI_TEXTURE_REPEAT:
bi.setRGB(x,y,onbi.getRGB(x,y));
break;
default:
bi.setRGB(x,y,ni.getAfterColor());
break;
		}
ni.setFinish(x,y);
	}
/**
biに実際に塗りつぶし処理を行う破壊的メソッドです。
アルゴリズムとしては
指定した位置から捜索位置を開始し、捜索位置が塗りつぶし対象の色である縦列を塗りつぶしながら左右が塗りつぶす前の色（beforeCol）である状態の位置のリストを作る行動を開始
↓
塗りつぶしが完了したらリストを元にリストに登録した色の位置を元にまた同じように再帰処理で縦列の塗りつぶし及びリストへの登録を行う（リストに登録されている位置で既に塗りつぶしが終わっている場合そこの塗りつぶしは行わない）
↓
これを繰り返す。既に塗りつぶしが終わっている場合その位置の塗りつぶしを行わないことを利用して、すべて塗りつぶし終わっていた場合塗りつぶし処理を行わなくなり、再帰処理を行わないのでループ処理を抜け出す

ただし、現状では塗りつぶし対象の色が開始位置と一致している色（beforeCol）でなければならないので、線画塗り判定は改善しないと組み込むことができない
*/
private static void protNuriTubusiY(BufferedImage img,BufferedImage onimg,int sx,int sy,int beforeCol,int houkou,NuriInfo ni)
	{
if(nuriDoHantei(img,onimg,sx,sy,beforeCol,ni))
		{
int motosy=sy;
ArrayList<Integer> divid = new ArrayList<>();
ArrayList<Integer> dividreverse = new ArrayList<>();
//+
try
			{
while(nuriHantei(img,onimg,sx,sy,beforeCol,ni) && sy>=0)
				{
nuriSetRGB(img,onimg,sx,sy,beforeCol,ni);
//++
if(nuriHantei(img,onimg,sx+houkou,sy,beforeCol,ni))
					{
dividreverse.add(sy);
					}
//+-
if(nuriHantei(img,onimg,sx-houkou,sy,beforeCol,ni))
					{
divid.add(sy);
					}
sy=sy-1;
				}
			}
catch(ArrayIndexOutOfBoundsException e)
			{
;
			}
sy=motosy+1;
//-
try
			{
while(nuriHantei(img,onimg,sx,sy,beforeCol,ni))
				{
nuriSetRGB(img,onimg,sx,sy,beforeCol,ni);
//-+
if(nuriHantei(img,onimg,sx+houkou,sy,beforeCol,ni))
					{
dividreverse.add(sy);
					}
//--
if(nuriHantei(img,onimg,sx-houkou,sy,beforeCol,ni))
					{
divid.add(sy);
					}
sy=sy+1;
				}
			}
catch(ArrayIndexOutOfBoundsException e)
			{
;
			}
int cou;
for(cou=0;dividreverse.size()>cou;cou++)
			{
protNuriTubusiY(img,onimg,sx+houkou,dividreverse.get(cou),beforeCol,houkou,ni);
			}
for(cou=0;divid.size()>cou;cou++)
			{
protNuriTubusiY(img,onimg,sx-houkou,divid.get(cou),beforeCol,-1*houkou,ni);
			}
		}
	}
/**
bi.getRGB(x,y)を、biue.getRGB(x,y)のオーバーレイ結果をai(AfterImage)の(x,y)位置に代入します。
*/
public static void overlaySetRGB(BufferedImage ai,BufferedImage underImage,BufferedImage onImage,int x,int y)
	{
ai.setRGB(x,y,getOverlayARGB(underImage.getRGB(x,y),onImage.getRGB(x,y)));
	}
public static int getOverlayARGB(int underARGB,int onARGB)
	{
int onAlpha=onARGB>>>24;
if(onAlpha==0xff)
		{
return onARGB;
		}
else if(onAlpha==0x0)
		{
return underARGB;
		}
int underAlpha=underARGB>>>24;
int underRGB=(underARGB<<8)>>>8;
int onRGB=(onARGB<<8)>>>8;

int outAlpha=onAlpha+((underAlpha*(255-onAlpha))/255);
if(outAlpha>255)
		{
outAlpha=255;
		}
int cou=1;
int outRGB=0;
while(cou<=3)
		{
int outCol=((((onRGB<<8*cou)>>>24)*onAlpha)+((((underRGB<<(8*cou))>>>24)*underAlpha*(255-onAlpha))/outAlpha))/255;
if(outCol>0xff)
			{	outCol=0xff;		}
else if(outCol<0)
			{	outCol=0;		}
outRGB=outRGB+(outCol<<(8*(3-cou)));
cou=cou+1;
		}
return outRGB+(outAlpha<<24);
	}
public static BufferedImage reverseImage(BufferedImage bi,int direction)
	{
boolean hol=false;
boolean per=false;
if(((direction%2)/1)==1)
		{
hol=true;
		}
if((direction%4)/2==1)
		{
per=true;
		}
BufferedImage retBI=makeNewCopyBufferedImage(bi);
for(int x=0;x<retBI.getWidth();x++)
		{
for(int y=0;y<retBI.getHeight();y++)
			{
int getX=x;
int getY=y;
if(hol)
				{
getX=bi.getWidth()-(x+1);
				}
if(per)
				{
getY=bi.getHeight()-(y+1);
				}
retBI.setRGB(x,y,bi.getRGB(getX,getY));
			}
		}
return retBI;
	}
}
class DrawLine
{
private static DrawLineObject DO=new DrawLineObject();
private static DrawThickLineObject DTO=new DrawThickLineObject();
private static DrawAntiAliasLineObject DAAO= new DrawAntiAliasLineObject();
private DrawLine(){;}
public static void drawLine(BufferedImage bi,int startx,int starty,int endx,int endy,DrawLineInfo info)
	{
DO.drawLine(bi,startx,starty,endx,endy,info);
	}
public static void drawThickLine(BufferedImage bi,int startx,int starty,int endx,int endy,DrawLineInfo info)
	{
DTO.drawLine(bi,startx,starty,endx,endy,info);
	}
public static void drawAntiAliasLine(BufferedImage bi,int startx,int starty,int endx,int endy,DrawLineInfo info)
	{
DAAO.drawLine(bi,startx,starty,endx,endy,info);
	}
}
class DrawLineObject
{
DrawLineObject(){}
void drawLine(BufferedImage bi,int startx,int starty,int endx,int endy,DrawLineInfo info)
	{
boolean chokutateflg=(startx==endx);
double keisuu=0;
if(!chokutateflg)
		{
keisuu= ((double)(starty-endy)/(double)(startx-endx));
		}
int seppen= starty-(int)(startx*keisuu);

int ex=Math.max(startx,endx);
int sx=Math.min(startx,endx);
int ey=Math.max(starty,endy);
int sy=Math.min(starty,endy);
if(chokutateflg)
		{
//tatemuki line
while(ey>=sy)
			{
setStandColor(bi,startx,sy,info);
sy++;
			}
		}
else if(starty==endy)
		{
//mayokomuki line
while(ex>=sx)
			{
setFallColor(bi,sx,starty,info);
sx++;
			}
		}
else if(Math.abs(keisuu)<1)
		{
while(ex>=sx)
			{
setFallColor(bi,sx,(int)((sx*keisuu)+seppen),info);
sx++;
			}
		}
else
		{
while(ey>=sy)
			{
setStandColor(bi,(int)((sy-seppen)/keisuu),sy,info);
sy++;
			}
		}
	}
//横側に倒れてる直線(傾きの絶対値1未満)
void setFallColor(BufferedImage bi,int x,int y,DrawLineInfo info)
	{
setColor(bi,x,y,info);
	}
//縦側に倒れてる直線(傾きの絶対値1以上)
void setStandColor(BufferedImage bi,int x,int y,DrawLineInfo info)
	{
setColor(bi,x,y,info);
	}
void setColor(BufferedImage bi,int x,int y,DrawLineInfo info)
	{
if(x>=0 && y>=0 && x<bi.getWidth() && y<bi.getHeight())
		{
bi.setRGB(x,y,ImageChenge.getOverlayARGB(bi.getRGB(x,y),info.getColor()));
		}
	}
void setColor(BufferedImage bi,int x,int y,int color)
	{
if(x>=0 && y>=0 && x<bi.getWidth() && y<bi.getHeight())
		{
bi.setRGB(x,y,ImageChenge.getOverlayARGB(bi.getRGB(x,y),color));
		}
	}
}
class DrawThickLineObject extends DrawLineObject
{
boolean getAAFlg()
	{
return false;
	}
int getDividThick()
	{
return 2;
	}
int circleColor(DrawLineInfo info)
	{
return (info.getAlpha()<<24)+info.getRGB();
	}
void drawLine(BufferedImage bi,int startx,int starty,int endx,int endy,DrawLineInfo info)
	{
ImageChenge.fillCircle(bi,startx,starty,info.getThick()/getDividThick(),circleColor(info),getAAFlg());
super.drawLine(bi,startx,starty,endx,endy,info);
ImageChenge.fillCircle(bi,endx,endy,info.getThick()/getDividThick(),circleColor(info),getAAFlg());
	}
@Override
void setFallColor(BufferedImage bi,int x,int y,DrawLineInfo info)
	{
int sign=2;
for(info.setTmp1(1);info.getTmp1()<=info.getThick();info.tmp1PlusPlus())
				{
int ly=y+(info.getTmp1()/sign);
setColor(bi,x,ly,info);
sign=0-sign;
				}
	}
@Override
void setStandColor(BufferedImage bi,int x,int y,DrawLineInfo info)
	{
int sign=2;
for(info.setTmp1(1);info.getTmp1()<=info.getThick();info.tmp1PlusPlus())
		{
int lx=x+(info.getTmp1()/sign);
setColor(bi,lx,y,info);
sign=0-sign;
		}
	}
}
class DrawAntiAliasLineObject extends DrawThickLineObject
{
@Override
boolean getAAFlg()
	{
return true;
	}
@Override
int getDividThick()
	{
return 3;
	}
@Override
int circleColor(DrawLineInfo info)
	{
return ((info.getAlpha()*7/2)<<24)+info.getRGB();
	}
@Override
void setColor(BufferedImage bi,int x,int y,DrawLineInfo info)
	{
setColor(bi,x,y,(info.getRGB()+((255-(info.getAlpha()*info.getTmp1()/info.getThick()))<<24)));
	}
}
class NuriInfo
{
private int NURIMODE = 0;
private int nuriBorder=0;
private int afterColor=0;
private boolean finishingFlg[][];
NuriInfo(int width,int height,int acol,int m,int nb)
	{
NURIMODE=m;
nuriBorder=Math.abs(nb);
afterColor=acol;
finishingFlg= new boolean[width][height];
for(int x=0;x<width;x++)
		{
for(int y=0;y<height;y++)
			{
finishingFlg[x][y]=false;
			}
		}
	}
void setFinish(int x,int y)
	{
finishingFlg[x][y]=true;
	}
boolean getFinish(int x,int y)
	{
return finishingFlg[x][y];
	}
int getMode()
	{
return NURIMODE;
	}
int getBorder()
	{
return nuriBorder;
	}
int getAfterColor()
	{
return afterColor;
	}
}
