/*
Copyright (C) 2017 Hayakuchi

This file is part of HinesmPaint.

HinesmPaint is free software.
You can redistribute HinesmPaint and/or modify it under the GPL Licence version3 and LGPL Licence version 3.
(GPL text and LGPL text in http://www.gnu.org/licenses/)

このプログラムはフリーソフトです。
あなたはGPLライセンスversion3及びLGPLライセンスversion3の元でこのプログラムを改変、再配布することが可能です。
(GPLとLGPLの内容は http://www.gnu.org/licenses/)にあります)
*/
package hinesm.util.gazobutton;

import java.awt.Graphics;
import java.awt.event.WindowEvent;
import java.awt.Color;
import java.awt.Font;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import hinesm.util.UtilPerform;

public class GDialog extends GazoFrame
{
public static enum DialogStatus
	{
NOT_SELECTING,OK,CANCEL,EXITED;
	}
//表示環境取得
private static java.awt.DisplayMode dm = java.awt.GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice().getDisplayMode();
private static int DWIDTH=dm.getWidth()/5;
private static int DHEIGHT=dm.getHeight()/10;
private static int DX=(dm.getWidth()-DWIDTH)/2;
private static int DY=(dm.getHeight()-DHEIGHT)/2;

private DialogStatus nowstate = DialogStatus.NOT_SELECTING;
private GDPanel gp;
public GDialog(String message)
	{
this(DX,DY,DWIDTH,DHEIGHT);
gp = new GDPanel(this);
gp.setBounds(0,0,DWIDTH,DHEIGHT);
gp.setMessage(message);
addGazoPanel(gp);
	}
public DialogStatus getStatus()
	{
return nowstate;
	}
public void setStatus(DialogStatus st)
	{
if(st!=null)
		{
nowstate=st;
		}
	}
@Override
public void setVisible(boolean b)
	{
super.setVisible(b);
if(b)
		{
nowstate=DialogStatus.NOT_SELECTING;
		}
else
		{
nowstate=DialogStatus.EXITED;
		}
	}
@Override
public void windowClosed(WindowEvent e)
	{
nowstate=DialogStatus.EXITED;
	}
private GDialog()
	{
super();
	}
private GDialog(int x,int y,int width,int height)
	{
super(x,y,width,height);
	}
public void constracter()
	{;}
public void loopingPerform()
	{;}
@Override
public void keyReleased(KeyEvent e)
	{
super.keyReleased(e);
gp.keyReleased(e);
	}
}
class GDPanel extends GazoPanel
{
GDialog used;
PushButton OKButton;
PushButton CANCELButton;
Font viewFont= new Font(Font.MONOSPACED,Font.PLAIN,10);
String mes="";
String okStr="OK";
String cancelStr="キャンセル";
int drawX=0;
int drawY=0;
protected GDPanel(GDialog gd)
	{
this();
used=gd;
	}
private GDPanel()
	{
super();
	}
@Override
public void loopingPerform()
	{
if(OKButton==null)
		{
OKButton= new StateButton(okStr,this,used,GDialog.DialogStatus.OK,getWidth()/5,getHeight()*2/3,getWidth()/5,getHeight()/6);
drawX=getWidth()/20;
drawY=getHeight()/3;
viewFont=new Font(OKButton.getTitleFont().getFontName(),OKButton.getTitleFont().getStyle(),UtilPerform.getFontSize(Math.min(getHeight()/4,((getWidth()*4)/(5*(mes.length()+1))))));
		}
if(CANCELButton==null)
		{
CANCELButton= new StateButton(cancelStr,this,used,GDialog.DialogStatus.CANCEL,getWidth()*3/5,getHeight()*2/3,getWidth()/5,getHeight()/6);
		}
	}
@Override
public void drawTopLayer(Graphics g)
	{
g.setColor(Color.black);
g.setFont(viewFont);
g.drawString(mes,drawX,drawY);
	}
@Override
public void keyReleased(KeyEvent e)
	{
if(e.getKeyCode()==KeyEvent.VK_ENTER)
		{
used.setVisible(false);
if((CANCELButton!=null) && CANCELButton.thisTabNow())
			{
used.setStatus(GDialog.DialogStatus.CANCEL);
			}
else
			{
used.setStatus(GDialog.DialogStatus.OK);
			}
		}
	}
@Override
public void drawBottomLayer(Graphics g)
	{;}
protected void setMessage(String str)
	{
mes=str;
	}
}
class StateButton extends PushButton
{
GDialog thisgd;
GDialog.DialogStatus thisst;
StateButton(String str,GDPanel gp,GDialog gd,GDialog.DialogStatus setst,int... st)
	{
super(str,gp,st);
thisgd=gd;
thisst=setst;
	}
@Override
public void perform()
	{
thisgd.setVisible(false);
thisgd.setStatus(thisst);
	}
}
