/*
Copyright (C) 2017 Hayakuchi

This file is part of HinesmPaint.

HinesmPaint is free software.
You can redistribute HinesmPaint and/or modify it under the GPL Licence version3 and LGPL Licence version 3.
(GPL text and LGPL text in http://www.gnu.org/licenses/)

このプログラムはフリーソフトです。
あなたはGPLライセンスversion3及びLGPLライセンスversion3の元でこのプログラムを改変、再配布することが可能です。
(GPLとLGPLの内容は http://www.gnu.org/licenses/)にあります)
*/
package hinesm.util.gazobutton;

import java.awt.Frame;
import java.awt.Insets;
import java.awt.event.ComponentEvent;
import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.util.ArrayList;

public abstract class GazoFrame extends Frame implements KeyListener,Runnable,WindowListener
{
private boolean maximizeflg;
private int LOOP_CYCLE=100;
private ArrayList<GazoPanel> putPanels = new ArrayList<GazoPanel>();

public GazoFrame()
	{
super();
setLayout(null);
addWindowListener(this);
addKeyListener(this);
setBounds(0,0,10,10);
setExtendedState(Frame.MAXIMIZED_BOTH);
firstconstracter();
setVisible(true);
Insets is = getInsets();
while((getWidth()<=(is.left+is.right+2)) || ((getHeight()<is.top+is.bottom+2)))
		{
try
			{
Thread.sleep(50);
			}
catch(Exception e)
			{
e.printStackTrace();
			}
		}
GazoButton.setUseLanguage(GazoButton.UseLanguage.JAPANESE);
constracter();
enableEvents(java.awt.AWTEvent.COMPONENT_EVENT_MASK);
maximizeflg=true;
setMinimumSize(new java.awt.Dimension(800,600));
Thread th = new Thread(this);
th.start();
	}
public GazoFrame(int x,int y,int width,int height)
	{
this();
maximizeflg=false;
setExtendedState(Frame.NORMAL);
setBounds(x,y,width,height);
setMinimumSize(new java.awt.Dimension(width,height));
setMaximizedBounds(new java.awt.Rectangle(width,height));
	}
public void run()
	{
boolean contflg=true;
long before=System.currentTimeMillis();
while(contflg)
		{
before=System.currentTimeMillis()+getLoopCycle();
loopingPerform();
try
			{
for(int i=0;i<putPanels.size();i++)
				{
putPanels.get(i).panelPaint();
				}
while(before>(System.currentTimeMillis()))
				{
Thread.sleep(5);
				}
			}
catch(Exception e)
			{
e.printStackTrace();
			}
		}
	}
public void setLoopCycle(int ms)
	{
LOOP_CYCLE=ms;
	}
public int getLoopCycle()
	{
return LOOP_CYCLE;
	}
public void addGazoPanel(GazoPanel gp)
	{
if(gp!=null)
		{
putPanels.add(gp);
add(gp);
		}
	}
@Override
public void windowActivated(WindowEvent e)
	{;}
@Override
public void windowClosed(WindowEvent e)
	{;}
@Override
public void windowClosing(WindowEvent e)
	{
setVisible(false);
	}
@Override
public void windowIconified(WindowEvent e)
	{;}
@Override
public void windowDeactivated(WindowEvent e)
	{;}
@Override
public void windowDeiconified(WindowEvent e)
	{;}
@Override
public void windowOpened(WindowEvent e)
	{;}


@Override
public void keyPressed(KeyEvent e)
	{
GazoButton.keyPressedPerformAll(e);
	}
@Override
public void keyTyped(KeyEvent e)
	{
GazoButton.keyTypedPerformAll(e);
	}
@Override
public void keyReleased(KeyEvent e)
	{
GazoButton.keyReleasedPerformAll(e);
	}
@Override
public void processComponentEvent(ComponentEvent e)
	{
	}
public abstract void constracter();
public void firstconstracter(){;}
public abstract void loopingPerform();
}
