/*
Copyright (C) 2017 Hayakuchi

This file is part of HinesmPaint.

HinesmPaint is free software.
You can redistribute HinesmPaint and/or modify it under the GPL Licence version3 and LGPL Licence version 3.
(GPL text and LGPL text in http://www.gnu.org/licenses/)

このプログラムはフリーソフトです。
あなたはGPLライセンスversion3及びLGPLライセンスversion3の元でこのプログラムを改変、再配布することが可能です。
(GPLとLGPLの内容は http://www.gnu.org/licenses/)にあります)
*/
package hinesm.util.gazobutton;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Panel;
import java.awt.event.ComponentEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseEvent;
import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;
import java.awt.LayoutManager;
import java.awt.Toolkit;

public abstract class GazoPanel extends Panel implements MouseListener,MouseMotionListener,KeyListener
{
Image dbImage;
Graphics dbgr;
public GazoPanel()
	{
super();
constracter();
	}
public GazoPanel(LayoutManager lm)
	{
super(lm);
constracter();
	}
private void constracter()
	{
addMouseListener(this);
addMouseMotionListener(this);
addKeyListener(this);
setBounds(0,0,10,10);
	}
public final void panelPaint()
	{
if(dbImage==null)
		{
dbImage=createImage(getWidth(),getHeight());
		}
if((dbgr==null) && (dbImage!=null))
		{
dbgr=dbImage.getGraphics();
		}
loopingPerform();
if(dbgr!=null)
		{
dbgr.setColor(Color.white);
dbgr.fillRect(0,0,getWidth(),getHeight());
drawBottomLayer(dbgr);
GazoButton.putAll(dbgr,this);
drawTopLayer(dbgr);
		}
Graphics g = getGraphics();
if(g!=null && (dbImage!=null))
		{
Toolkit.getDefaultToolkit().sync();
g.drawImage(dbImage,0,0,this);
g.dispose();
		}
	}
abstract public void drawTopLayer(Graphics g);
abstract public void drawBottomLayer(Graphics g);
abstract public void loopingPerform();
@Override
public void mouseReleased(MouseEvent e)
	{
GazoButton.mouseReleasedPerformAll(e);
	}
@Override
public void mousePressed(MouseEvent e)
	{
GazoButton.mousePressedPerformAll(e);
	}
@Override
public void mouseClicked(MouseEvent e)
	{
GazoButton.mouseClickedPerformAll(e);
	}
@Override
public void mouseEntered(MouseEvent e)
	{
GazoButton.mouseEnteredPerformAll(e);
	}
@Override
public void mouseExited(MouseEvent e)
	{
GazoButton.mouseExitedPerformAll(e);
	}
@Override
public void mouseDragged(MouseEvent e)
	{
GazoButton.mouseDraggedPerformAll(e);
	}
@Override
public void mouseMoved(MouseEvent e)
	{
GazoButton.mouseMovedPerformAll(e);
	}
@Override
public void keyPressed(KeyEvent e)
	{
GazoButton.keyPressedPerformAll(e);
	}
@Override
public void keyReleased(KeyEvent e)
	{
GazoButton.keyReleasedPerformAll(e);
	}
@Override
public void keyTyped(KeyEvent e)
	{
GazoButton.keyTypedPerformAll(e);
	}
@Override
public void update(Graphics g)
	{
paint(g);
	}

}
