/*
Copyright (C) 2017 Hayakuchi

This file is part of HinesmPaint.

HinesmPaint is free software.
You can redistribute HinesmPaint and/or modify it under the GPL Licence version3 and LGPL Licence version 3.
(GPL text and LGPL text in http://www.gnu.org/licenses/)

このプログラムはフリーソフトです。
あなたはGPLライセンスversion3及びLGPLライセンスversion3の元でこのプログラムを改変、再配布することが可能です。
(GPLとLGPLの内容は http://www.gnu.org/licenses/)にあります)
*/
package hinesm.util.gazobutton;

import java.awt.Component;
import java.awt.event.KeyEvent;
import java.awt.event.InputMethodListener;
import java.awt.event.InputMethodEvent;
import java.awt.Graphics;
import java.awt.Font;
import java.awt.Color;
import hinesm.util.UtilPerform;

public class GazoText extends GazoButton
{
private boolean ctrlFlg=false;
private int cursor=0;
private int mojisuu;
private int shownum;
private int stick=0;
private int sideSpaceLength;
private int sideLineLength;
private Color stickcolor= new Color(0x7f000000,true);
private Color backGroundColor=new Color(0x3f000000,true);
private String backGroundTitle;
public GazoText(Component c,int ...stetus)
	{
this("",c,stetus);
cnst(null,0);
	}
public GazoText(String s,Component c,int... stetus)
	{
super("",c,stetus);
if((stetus.length%2)==1)
		{
cnst(s,stetus[(stetus.length-1)]);
		}
else
		{
cnst(s,0);
		}
	}
private void cnst(String s,int m)
	{
if((s==null) && (m<=0))
		{
setBackGroundTitle("文字を入力してください");
notCursorMoveSetTitle("");
		}
else
		{
setBackGroundTitle(s);
notCursorMoveSetTitle("");
		}
if(getWidth()%getHeight()!=0)
		{
setMojisuu(getWidth()/getHeight());
		}
else
		{
setMojisuu(getWidth()/getHeight()-1);
		}
	}

public void notCursorMoveSetTitle(String s)
	{
super.setTitle(s);
	}

private void setBackGroundTitle(String s)
	{
backGroundTitle=s;
	}
private String getBackGroundTitle()
	{
return backGroundTitle;
	}

@Override
public void setTitle(String s)
	{
super.setTitle(s);
cursorMove(getCursor()*-1,0);
cursorMove(getTitle().length(),0);
	}

private void privateSetStickColor(Color c)
	{
privateSetStickColor(c.getRGB());
	}
private void privateSetStickColor(int c)
	{
int newcol =(c<<8)>>>8;
int newStickAlpha = (c>>>25)<<24;
int newBackGroundAlpha=(c>>>26)<<24;
if(stickcolor.getRGB()!=newcol)
		{
this.stickcolor=new Color(newStickAlpha+newcol,true);
this.backGroundColor=new Color(newBackGroundAlpha+newcol,true);
		}
	}
@Override
public void setTitleColor(int c,boolean a)
	{
super.setTitleColor(c,a);
privateSetStickColor(c);
	}
@Override
public void setTitleColor(Color c)
	{
super.setTitleColor(c);
privateSetStickColor(c);
	}
@Override
public void perform()
	{
	}
private void setMojisuu(int m)
	{
mojisuu=m;
shownum=0;
StringBuilder sb = new StringBuilder("a");
int cou = 1;
while(cou<m)
		{
sb.append("a");
cou=cou+1;
		}
titlefont = new Font(getDefaultFontString(),DEFAULT_FONT_STYLE,UtilPerform.getFontSize(difineFontDot(sb.toString(),getWidth(),getHeight())));
cursorMove(mojisuu,0);
sideLineLength=getFontDot()/3;
sideSpaceLength=(getFontDot()/2);
	}
@Override
public void keyTypedPerform(KeyEvent e)
	{
if(thisTabNow()&&(!ctrlFlg))
		{
switch(e.getKeyChar())
			{
case '\n':
pushEnterPerform();
break;
case '\b':
if(title.length()>0 && getCursor()>0)
				{
notCursorMoveSetTitle(title.deleteCharAt(getCursor()-1).toString());
				}
cursorMove(-1,0);
break;
default:
notCursorMoveSetTitle(title.insert(getCursor(),e.getKeyChar()).toString());
cursorMove(1,0);
break;
			}
		}
	}
@Override
public void keyReleasedPerform(KeyEvent e)
	{
if(thisTabNow() && e.getKeyChar()==KeyEvent.CHAR_UNDEFINED)
		{
int c=e.getKeyCode();
switch(c)
			{
case KeyEvent.VK_RIGHT:
cursorMove(1,0);
break;
case KeyEvent.VK_LEFT:
/*
case KeyEvent.VK_UP:
cursorMove(0,-1);
break;
case KeyEvent.VK_DOWN:
cursorMove(0,1);
break;
*/
cursorMove(-1,0);
break;
default:
break;
			}
		}
	}
public int getCursor()
	{
return cursor;
	}

@Override
public void drawAny(Graphics g)
	{
if(thisTabNow())
		{
g.setColor(getTitleColor());
		}
else
		{
g.setColor(backGroundColor);
g.setFont(getTitleFont());
g.drawString(getBackGroundTitle(),getX(),getY()+getHeight()*3/4);
g.setColor(stickcolor);
		}
if(stick<=0)
			{
g.drawLine(getX()+sideSpaceLength,getY(),getX()+sideSpaceLength,getY()+getHeight());
			}
else if(stick>=mojisuu && mojisuu>=1)
			{
g.drawLine(getX()+((stick+1)*getFontDot())-sideSpaceLength,getY(),getX()+((stick+1)*getFontDot())-sideSpaceLength,getY()+getHeight());
			}
else
			{
g.drawLine(getX()+(stick*getFontDot()),getY(),getX()+(stick*getFontDot()),getY()+getHeight());
			}
g.setColor(gc);
	}
@Override
public void drawTitle(Graphics g)
	{
//文字を描きます
g.setFont(this.getTitleFont());
g.setColor(this.getTitleColor());
int cou=0;
if(titlestring!=null)
		{
while(mojisuu>cou && titlestring.length>shownum+cou)
			{
g.drawString(titlestring[shownum+cou],getX()+sideSpaceLength+(getFontDot()*cou),getY()+(getHeight()*3/4));
cou=cou+1;
			}
		}
if(shownum>0)
		{
int ccc=1;
while(ccc<4)
			{
int drawy=getY()+((getHeight()*ccc)/5);
g.drawLine(getX(),drawy,getX()+sideLineLength,drawy);
ccc=ccc+1;
			}
		}
if(shownum+mojisuu<titlestring.length)
		{
int cccc=1;
while(cccc<5)
			{
int drawy=getY()+((getHeight()*cccc)/5);
g.drawLine(getX()+getWidth(),drawy,getX()+getWidth()-sideLineLength,drawy);
cccc=cccc+1;
			}
		}
g.setFont(gf);
	}

public void cursorMove(int right,int up)
	{
cursor=cursor+right;
stick=stick+right;
if(cursor<0)
		{
cursor=0;
stick=0;
		}
else if(cursor>title.toString().length())
		{
cursor=title.toString().length();
if(mojisuu>title.toString().length())
			{
stick=title.toString().length();
			}
else
			{
stick=mojisuu;
			}
		}

if(cursor<shownum)
		{
shownum=cursor;
stick=0;
		}
else if(cursor>shownum+mojisuu)
		{
shownum=cursor-mojisuu;
stick=mojisuu;
		}
	}
public void pushEnterPerform()
	{
;
	}
}
