/*
Copyright (C) 2017 Hayakuchi

This file is part of HinesmPaint.

HinesmPaint is free software.
You can redistribute HinesmPaint and/or modify it under the GPL Licence version3 and LGPL Licence version 3.
(GPL text and LGPL text in http://www.gnu.org/licenses/)

このプログラムはフリーソフトです。
あなたはGPLライセンスversion3及びLGPLライセンスversion3の元でこのプログラムを改変、再配布することが可能です。
(GPLとLGPLの内容は http://www.gnu.org/licenses/)にあります)
*/
package hinesm.util.gazobutton;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.Font;
import java.util.ArrayList;
import hinesm.util.UtilPerform;

public class MessageWindow extends GazoButton
{
	
private ArrayList<String> messagecontent=new ArrayList<String>();
private ArrayList<Message> message = new ArrayList<Message>();
private int linecount;
private int viewnum;
private int maxpoint;

private MessageWindow(String s,Component c,int ...stetus)
	{super(s,c,stetus);}
private MessageWindow(Component c,int...stetus)
	{super(c,stetus);}
private MessageWindow(int lc,Component c,int x,int y,int width,int height)
	{
super(c,x,y,width,height);
setLine(lc);
setTitleFont(new Font(getDefaultFontString(),DEFAULT_FONT_STYLE,getFontPoint()));
setTabUseFlg(false);
	}

public static MessageWindow createMessageWindow(Component c,int x,int y,int width,int height,int lc,String... s)
	{
MessageWindow ms = new MessageWindow(lc,c,x,y,width,height);
int cou=0;
ms.setMessage(" ",true,-1);
while(cou<s.length)
		{
ms.setMessage(s[cou],true,-1);
cou=cou+1;
		}
return ms;
	}

private int getFontPoint()
	{
return UtilPerform.getFontSize(difineFontDot(getTitle(),getWidth(),getHeight()));
	}

@Override
public int difineFontDot(String s,int gW,int gH)
	{
int ngH=gH;
if(getLine()>0)
		{
ngH=gH/getLine();
		}
return super.difineFontDot(s,gW,ngH);
	}

/**
表示させる文字列を追加します。
改行が入る場合行ごとに分けて追加されます。
また、表示させる行を追加する行にする場合changeの引数にtrueを代入してください
*/
public void setMessage(String s,boolean change,int setnumber)
	{
int sn=setnumber;
int ncou=0;
if(sn<0 || sn>messagecontent.size())
		{
messagecontent.add(s);
message.add(new Message());
sn=message.size()-1;
		}
else
		{
messagecontent.set(sn,s);
sn=sn-1;
message.set(sn,new Message());
		}
if(s.indexOf("\n")==-1)
		{
try
			{
message.get(sn).setMessage(s);
ncou=ncou+1;
			}
catch(Exception e)
			{
e.printStackTrace();
			}
		}
else
		{
String kaigyou="\n";
int bnum =0;
int nnum =0;
while(nnum!=s.length())
			{
nnum=s.indexOf(kaigyou,bnum);
if(nnum==-1)
				{
nnum=s.length();
				}
message.get(sn).setMessage(s.substring(bnum,nnum));
bnum=nnum+1;
ncou=ncou+1;
			}
		}
if(change)
		{
setNowMessage(sn+1);
		}
for(int cou=0;cou<ncou;cou++)
		{
if(message.get(sn).showMessage(cou+1).length()>maxpoint)
			{
setTitleFont(new Font(getTitleFont().getFontName(),getTitleFont().getStyle(),UtilPerform.getFontSize(difineFontDot(message.get(sn).showMessage(cou+1),getWidth(),getHeight()))));
maxpoint=message.get(sn).showMessage(cou+1).length();
			}
		}
	}
/**
ウィンドウの最後に表示するメッセージを番号で指定して設定します。
*/
public void setNowMessage(int n)
	{
if(n<messagecontent.size())
		{
viewnum=n;
		}
else
		{
viewnum=messagecontent.size()-1;
		}
	}

public void setLine(int n)
	{
if(n>0)
		{
linecount=n;
		}
else
		{
linecount=1;
		}
	}

//Get Information Metheds

/**
引き数番目に格納された番号のメッセージを返します。
(0を代入した場合は半角スペース(" ")が返されます)
格納されていない番号を引数に指定された場合も同様の文字列を返します。
*/
public String getMessage(int num)
	{
if(num>0)
		{
try
			{
return messagecontent.get(num);
			}
catch(Exception e)
			{
return messagecontent.get(0);
			}
		}
else
		{
return messagecontent.get(0);
		}
	}
/**
引数となったString型の文字列を含む文字列で、最後に格納された番号を返します。
存在しなかった場合は0を返します。
*/
public int getNum(String s)
	{
int cou=1;
while(cou<=messagecontent.size())
		{
if(getMessage(cou).indexOf(s)>=0)
			{
return cou;
			}
cou=cou+1;
		}
return 0;
	}
public int getLine()
	{
return linecount;
	}
public int getNowMessage()
	{
return viewnum;
	}
//shori
//文字を描きます
@Override
public void drawTitle(Graphics g)
	{
g.setFont(this.getTitleFont());
g.setColor(this.getTitleColor());
int cou =1;
while(cou<=getLine())
		{
g.drawString(message.get(getNowMessage()).showMessage(showNumNow(cou)),getX(),getY()+(getFontDot()*3*cou/4));
cou=cou+1;
		}
//元の色とフォントに戻します
g.setFont(gf);
g.setColor(gc);
	}

private int showNumNow(int n)
	{
int ret=n;
if(ret<=0 || ret>message.get(getNowMessage()).getMesNum())
		{
ret=0;
		}
return ret;
	}
public int getTheNumberOfMessage()
	{
return (message.size()-1);
	}

@Override
public void perform()
	{;}
}
