/*
Copyright (C) 2017 Hayakuchi

This file is part of HinesmPaint.

HinesmPaint is free software.
You can redistribute HinesmPaint and/or modify it under the GPL Licence version3 and LGPL Licence version 3.
(GPL text and LGPL text in http://www.gnu.org/licenses/)

このプログラムはフリーソフトです。
あなたはGPLライセンスversion3及びLGPLライセンスversion3の元でこのプログラムを改変、再配布することが可能です。
(GPLとLGPLの内容は http://www.gnu.org/licenses/)にあります)
*/
package hinesm.util.gazobutton;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.event.MouseEvent;
import java.awt.event.KeyEvent;

public abstract class PushButton extends GazoButton
{
private int movingX=Integer.MAX_VALUE;
private int movingY=Integer.MAX_VALUE;
private static final Color maskColor = new Color(0x3f000000,true);
public PushButton(Component c,int... status)
	{
super(c,status);
constracter();
	}
public PushButton(String str,Component c,int... status)
	{
super(str,c,status);
constracter();
	}
protected void constracter()
	{;}
@Override
public void mouseReleasedPerform(MouseEvent e)
	{
ifContainPerform(e.getX(),e.getY());
	}
@Override
public void mouseMovedPerform(MouseEvent e)
	{
movingX=e.getX();
movingY=e.getY();
	}
@Override
public void drawAny(Graphics g)
	{
g.setColor(maskColor);

if(nowMounting())
		{
g.fillRect(getX(),getY(),getWidth(),getHeight());
		}
else
		{
g.drawRect(getX()+3,getY()+3,getWidth()-6,getHeight()-6);
		}
	}
private boolean nowMounting()
	{
return containCheck(movingX,movingY);
	}
@Override
public void keyReleasedPerform(KeyEvent e)
	{
if(thisTabNow() && (e.getKeyCode()==KeyEvent.VK_ENTER))
		{
perform();
		}
	}
}
