/*
Copyright (C) 2017 Hayakuchi

This file is part of HinesmPaint.

HinesmPaint is free software.
You can redistribute HinesmPaint and/or modify it under the GPL Licence version3 and LGPL Licence version 3.
(GPL text and LGPL text in http://www.gnu.org/licenses/)

このプログラムはフリーソフトです。
あなたはGPLライセンスversion3及びLGPLライセンスversion3の元でこのプログラムを改変、再配布することが可能です。
(GPLとLGPLの内容は http://www.gnu.org/licenses/)にあります)
*/
package hinesm.util.gazobutton;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.event.MouseEvent;
import java.awt.event.KeyEvent;

public class RadioButton extends GazoButton
{
	
private int selection=0;
private RadioSelectionButton[] RSB;
private GazoButton titleButton;
public static final Color DEFAULT_SELECTION_COLOR = new Color(0xff7f7fff,true);
public static final Color DEFAULT_SELECTION_CIRCLE_COLOR = new Color(0xff000000,true);
public static final Color DEFAULT_NOT_SELECTION_COLOR = new Color(0xffffffff,true); 
private int Line;
private int Haba;
//コンストラクタ
private RadioButton(Component c,int... stetus){super(c,stetus);}
private RadioButton(String s,Component c,int... stetus){super(s,c,stetus);}
public RadioButton(String s,Component c,int x,int y,int width,int height,Enum... en)
	{
this(s,c,x,y,width,height,1,en);
	}
public RadioButton(String s,Component c,int x,int y,int width,int height,int line,Enum... en)
	{
this(s,c,x,y,width,height,line,enumsToStrings(en));
	}
private static String[] enumsToStrings(Enum... en)
	{
int size = en.length;
String[] str = new String[size];
for(int i=0;i<size;i++)
		{
str[i]= en[i].toString();
		}
return str;
	}
public RadioButton(String s,Component c,int x,int y,int width,int height,String... ar)
	{
this(s,c,x,y,width,height,1,ar);
	}
public RadioButton(String s,Component c,int x,int y,int width,int height,int line,String... ar)
	{
super(s,c,x,y,width,height);
radioButtonConstracter(s,c,x,y,width,height,line,ar);
	}
private void radioButtonConstracter(String s,Component c,int x,int y,int width,int height,int line,String... ar)
	{
//make instans
if(line>0)
		{
Line=line;
		}
else
		{
Line=1;
		}
int addLine=0;
if((ar.length%Line)!=0)
		{
addLine=1;
		}
Haba=((ar.length)/Line)+addLine;
titleButton= new GazoButton(s,c,getX(),getY(),getWidth(),getHeight()/(Line+1))
		{
@Override
public void perform(){;}
		};
titleButton.setTabUseFlg(false);
titleButton.setFrameFlg(false);
addChildGazoButton(titleButton);
this.setFrameFlg(false);
this.setTitleFlg(false);
int arc=0;
int rsbw=getWidth()/Haba;
RSB = new RadioSelectionButton[ar.length];
while(ar.length>arc)
		{
RSB[arc] = new RadioSelectionButton(ar[arc],c,getX()+(rsbw*arc)%(Haba*rsbw),getY()+((getHeight()+(getHeight()*(arc/Haba)))/(Line+1)),rsbw,(getHeight()/(Line+1)));
addChildGazoButton(RSB[arc]);
arc=arc+1;
		}
setSelection(0);
	}
//コンストラクタここまで
public String getRBTitle(int s)
	{
String ret = this.getTitle();
try
		{
if(s>=0 && RSB.length>s)
			{
ret = RSB[s].getTitle();
			}
		}
catch(Exception e)
		{
System.out.println(e);
		}
return ret;
	}
@Override
public void drawAny(Graphics g)
	{
g.setColor(getFrameColor());
g.drawRect(getX(),getY(),getWidth(),getHeight());
for(int i=0;RSB.length>i;i++)
		{
if(i==getSelection())
			{
RSB[i].setColor(RadioButton.DEFAULT_SELECTION_COLOR);
			}
else
			{
RSB[i].setColor(RadioButton.DEFAULT_NOT_SELECTION_COLOR);
			}
		}
g.setColor(gc);
	}

private void setSelection(int s)
	{
if(0<=s && s<RSB.length)
		{
selection=s;
		}
	}
public int getSelection()
	{
return selection;
	}
public int getRadioSize()
	{
return RSB.length;
	}
@Override
public void perform()
	{
;
	}
@Override
public void mousePressedPerform(MouseEvent e)
	{
this.perform(e.getX(),e.getY());
	}
@Override
public void keyTypedPerform(KeyEvent e)
	{
	}
@Override
public void keyReleasedPerform(KeyEvent e)
	{
if(thisTabNow())
		{
if(e.getKeyChar()==KeyEvent.CHAR_UNDEFINED)
			{
switch(e.getKeyCode())
				{
case KeyEvent.VK_RIGHT:
setSelection(getSelection()+1);
break;
case KeyEvent.VK_LEFT:
setSelection(getSelection()-1);
break;
case KeyEvent.VK_UP:
setSelection(getSelection()-Haba);
break;
case KeyEvent.VK_DOWN:
setSelection(getSelection()+Haba);
break;
default:
break;
				}
			}
		}
	}

private void perform(int x,int y)
	{
int srb = 0;
while(RSB.length>srb)
		{
if(RSB[srb].containCheck(x,y))
			{
setSelection(srb);
			}
srb=srb+1;
		}

	}
}
