/*
Copyright (C) 2017 Hayakuchi

This file is part of HinesmPaint.

HinesmPaint is free software.
You can redistribute HinesmPaint and/or modify it under the GPL Licence version3 and LGPL Licence version 3.
(GPL text and LGPL text in http://www.gnu.org/licenses/)

このプログラムはフリーソフトです。
あなたはGPLライセンスversion3及びLGPLライセンスversion3の元でこのプログラムを改変、再配布することが可能です。
(GPLとLGPLの内容は http://www.gnu.org/licenses/)にあります)
*/
package hinesm.util.gazobutton;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.event.MouseEvent;

public class ScrollBar extends GazoButton
{

public static final boolean MODE_VERTICAL = true;// 縦向き
public static final boolean MODE_HORIZONTAL = false;// 横向き
private boolean DIRECTION;// 向き
private int LENGTH;// 表示上のバーの長さ
private int BREADTH;// 表示上の幅
private int SIZE;// 表示上のバーボタンの長さ
private int CLEARANCE;// LENGTH-SIZE
// バー本体の位置
private int BAR_X;
private int BAR_Y;

private boolean PRESSING_FLG;

private int LOCATION;// 内部的な1次元的な位置
private int LOCATION_LIMIT = 0;// 位置の最大値

private int clickX;
private int clickY;
private int draggingX;
private int draggingY;

private final int AUTO_MOVE_SPEED = 1;

public static final int MODE_DEFAULT = 0;
private static final int MODE_BOTTUN_MOVE = 1;
private static final int MODE_BACK_MOVE = 2;
private int mode = MODE_DEFAULT;

private ScrollBar(Component c, int... stetus)
	{
super(c, stetus);
	}

private ScrollBar(String s, Component c, int... stetus)
	{
super(s, c, stetus);
	}

public ScrollBar(int x, int y, int breadth, int length, boolean b, int maxlocation, Component c)
	{
super(c, x, y);
setBarLocate(x, y);
DIRECTION = b;
if (length > 0)
		{
LENGTH = length;
		}
else if (length != 0)
		{
LENGTH = (length * -1);
		}
else
		{
System.out.println("0 more than length");
LENGTH = c.getWidth();
		}
BREADTH = breadth;
LOCATION = 0;
this.setTitleFlg(false);
reset(maxlocation);
	}

public void reset(int maxlocation)
	{
int vl = LENGTH;
int bll=LOCATION_LIMIT;
if (maxlocation<=LENGTH)
		{
maxlocation = 1;
vl=maxlocation;
		}
SIZE=LENGTH*vl/maxlocation;
LOCATION_LIMIT = maxlocation;
CLEARANCE = LENGTH - SIZE;
if(CLEARANCE<=0)
		{
CLEARANCE =1;
		}
setBarButtonLocation(LOCATION*bll/maxlocation,true);
//DIRECTIONはMODE_VERTICALがtrue、MODE_HORIZONTALがfalse
if (DIRECTION)
		{
setSize(BREADTH, SIZE);
		}
else
		{
setSize(SIZE, BREADTH);
		}
	}

public int getLocate()
	{
return LOCATION;
	}
public int getMaxLocation()
	{
return LOCATION_LIMIT;
	}

public void setBarLocate(int x, int y)
	{
BAR_X = x;
BAR_Y = y;
	}

public void moveLocate(int d, boolean throwflg)
	{
setBarButtonLocation(LOCATION + d, throwflg);
	}

public void setBarButtonLocation(int loc, boolean throwflg)
	{
LOCATION = loc;
if (throwflg)
		{
if (LOCATION < 0)
			{
LOCATION = 0;
			}
else if (LOCATION > LOCATION_LIMIT)
			{
LOCATION = LOCATION_LIMIT;
			}
		}
	}

@Override
public void drawAny(Graphics g)
	{
shoriGameLoop();
try
		{
g.setColor(Color.black);
if (DIRECTION)
			{
// 縦長時
g.drawRect(BAR_X, BAR_Y, BREADTH, LENGTH);// 長方形作って・・・おしまい！

g.setColor(Color.darkGray);
g.drawRect(getX()+3,getY()+3,getWidth()-6,getHeight()-6);

setLocation(BAR_X, BAR_Y + ((CLEARANCE * LOCATION) / LOCATION_LIMIT));// 表示位置は向きとLENGTH*LOCATION/LOCATION_LIMITから叩き出す
			}
else
			{
// 横長時
g.drawRect(BAR_X, BAR_Y, LENGTH, BREADTH);
g.setColor(Color.darkGray);
g.drawRect(getX()+3,getY()+3,getWidth()-6,getHeight()-6);
setLocation(BAR_X + ((CLEARANCE * LOCATION) / LOCATION_LIMIT), BAR_Y);
			}
// 元の色に戻します
g.setColor(gc);
		}
catch (Exception e)
		{
System.out.println(e);
		}
	}

private void shoriGameLoop()
	{
if (PRESSING_FLG)
		{
switch (mode)
			{
case MODE_BOTTUN_MOVE:
moveLocateModeButtonMove();
break;
case MODE_BACK_MOVE:
moveLocateModeBackMove();
break;
default:
break;
			}
		}
	}

private void moveLocateModeButtonMove()
	{
if (DIRECTION)
		{
setBarButtonLocation(((draggingY - (SIZE / 2) - BAR_Y) * LOCATION_LIMIT) / CLEARANCE, true);
		}
else
		{
setBarButtonLocation(((draggingX - (SIZE / 2) - BAR_X) * LOCATION_LIMIT) / CLEARANCE, true);
		}
	}

private void moveLocateModeBackMove()
	{
if (DIRECTION)
		{
if (clickY > getY() + (SIZE / 2))
			{
moveLocate(AUTO_MOVE_SPEED, true);
			}
else if (clickY == getY() + (SIZE / 2))
			{
			}
else
			{
moveLocate(-1 * AUTO_MOVE_SPEED, true);
			}
		}
else
		{
if (clickX > getX() + (SIZE / 2))
			{
moveLocate(AUTO_MOVE_SPEED, true);
			}
else if (clickX == getX() + (SIZE / 2))
			{
			}
			else
			{
moveLocate(-1 * AUTO_MOVE_SPEED, true);
			}
		}
	}

@Override
public void mousePressedPerform(MouseEvent e)
	{
PRESSING_FLG = inBarCheck(e.getX(), e.getY());// バーの中をクリックされていた場合
if (PRESSING_FLG)
		{
clickX = e.getX();
clickY = e.getY();
if (containCheck(clickX, clickY))
			{
mode = MODE_BOTTUN_MOVE;
			}
else
			{
mode = MODE_BACK_MOVE;
			}
		}
	}

private boolean inBarCheck(int x, int y)
	{
if (DIRECTION)
		{
return BAR_X <= x && BAR_Y <= y && x <= (BAR_X + BREADTH) && y <= (BAR_Y + LENGTH);
		}
else
		{
return BAR_X <= x && BAR_Y <= y && x <= (BAR_X + LENGTH) && y <= (BAR_Y + BREADTH);
		}
	}

@Override
public void mouseDraggedPerform(MouseEvent e)
	{
if (PRESSING_FLG)
		{
draggingX = e.getX();
draggingY = e.getY();
		}
	}

@Override
public void mouseReleasedPerform(MouseEvent e)
	{
if (PRESSING_FLG)
		{
mode = MODE_DEFAULT;
PRESSING_FLG = false;
		}
	}
@Override
public void perform()
	{;}
}
